
-- Key for output: C=Chat, Y=Yell, E=Emote, CE=Custom Emote, PC=Party Chat, PL = Party Leader
-- UE=Unequip, EQ=Equip, CB=Combat, P=Poll, TGT=Target, BU=Bag Update, RegenON=proxy for when player enter combat
-- RegenOFF=proxy for when player exits combat, TRDCancel= cancel trade, TRDReq=Requesting trade, JMP=Jump
-- SRL: Replace RegenON and RegenOFF with OutComb and InComb, respectively (descriptions above are backwards)





function initializeParticipantSection()
	--SRL added, and will check SCinitializedParticipant for each function below, and return if 0
	--print("successfully initialized participant")
	SCinitializedParticipant = 1;
	location = ""
	hour = 0
	minute = 0
	mods = ""
	chat = ""
	guildchat = ""
	localchat = ""
	debugCounter = 0
	cursorUpdate = 0
	combat = ""
	output = ""
	strDate = ""
	startLogging = 0
	bagItemsBefore = {}
	bagItemsAfter = {}
	spellType = ""
	playerMoney=0
	--playerTradeMoney=0
	itemPush=0
	count = 0
	firstPollReceived = 0
	-- for holding equipped items
	equippedItems = {}
	merchantUpdate = 0
	money = 0

	NPCstart = RegisterAddonMessagePrefix("test")
	success = RegisterAddonMessagePrefix("poll")
	--print("poll registration: " .. tostring(success));
end


function MsendToResearcherLogger(output, msgType)
	--print("called MsendToResearcherLogger: " .. msgType .. "with message: " .. output);
	if SCinitializedParticipant == 0 then
		return
	end

	if msgType == "stats" then
		SendAddonMessage("stats", output, "PARTY")
		--print("MsendToResearcherLogger sent addon message stats to party");

	elseif msgType == "status" then
		SendAddonMessage("status", output, "PARTY")
		--print("MsendToResearcherLogger sent addon message status to party");

	elseif msgType == "bag" then
		SendAddonMessage("bag", output, "PARTY")
		--print("MsendToResearcherLogger sent addon message with prefix bag to PARTY");

	elseif msgType == "chatAndEvents" then
		SendAddonMessage("log", output, "PARTY")
		--print("MsendToResearcherLogger sent addon message with prefix log to PARTY");
	end
end
