

-- #######################################################
-- Var ini
-- #######################################################
SCversion = "4.0.4";

--Register to receive AddonMessages with desired prefixes
p0 = RegisterAddonMessagePrefix("SRRv1");
p1 = RegisterAddonMessagePrefix("SRv1");
p2 = RegisterAddonMessagePrefix("SCv1");
p3 = RegisterAddonMessagePrefix("SC2Rv1");
p5 = RegisterAddonMessagePrefix("SReset");
p6 = RegisterAddonMessagePrefix("SCRANK");
p8 = RegisterAddonMessagePrefix("SCver");
p9 = RegisterAddonMessagePrefix("SRNAME");
p10 = RegisterAddonMessagePrefix("SRCLUE");
p11 = RegisterAddonMessagePrefix("SCQUESTS");
p12 = RegisterAddonMessagePrefix("SCGUILDECHO");
p13 = RegisterAddonMessagePrefix("SCSHORTYELL");
p15 = RegisterAddonMessagePrefix("SCSHORTEMO");
p16 = RegisterAddonMessagePrefix("SCSHORTCUSTEMO");
p17 = RegisterAddonMessagePrefix("FACCOMM");
p17 = RegisterAddonMessagePrefix("poll");
p18 = RegisterAddonMessagePrefix("test");
p19 = RegisterAddonMessagePrefix("pollfwd");
--print(p0);
--print(p1);
--print(p2);
--print(p3);
--print(p5);
--print(p6);
--print(p8);
--print(p9);
--print(p10);
--print(p11);
--print(p12);
--print(p13)
--print(p14)
--print(p15)
--print(p16)
--print(p17)
--print(p18)
--print(p19)

--NPC variables
nAxe = "Axechew\195\171r"
npcAla = {hn = "Aladriaa", hr = "Forsaken", an = "Aladriea", ar = "Human",}
npcSed = {hn = "Seddrik", hr = "Blood Elf", an = "Sedrick", ar = "Human",}
npcCal = {hn = "Calliopia", hr = "Blood Elf", an = "Calliopi\195\164", ar = "Human",}
npcIzu = {hn = "Izunai", hr = "Goblin", an = "Izuna", ar = "Gnome",}
nAla, nCal, nIzu, nSed = ".", ".", ".", ".";
SCgroupname = "";
SCinitializedParticipant = 0;
SCSourceBaddie = "";
SCofflogs, SCsamelogs = 0, 0;
sameFacMsg = 0;


if (SCclue ~= nil) then
	if (SCclue == "") then
		SCcode = "99"
	else
		SCcode = SCclue
	end
else
	SCcode = "0"
end
local fg, fn = UnitFactionGroup("player");
if (fg == "Alliance") then
	--print("matched Alliance");
	nAla = npcAla.an;
	nAlaRace = npcAla.ar;
	nSed = npcSed.an;
	nSedRace = npcSed.ar;
	nCal = npcCal.an;
	nCalRace = npcCal.ar
	nIzu = npcIzu.hn; -- leave this, should be opposite cuz it's a foe
	nIzuRace = npcIzu.hr; -- leave this, should be opposite cuz it's a foe
elseif (fg == "Horde") then
	--print("matched Horde");
	nAla = npcAla.hn;
	nAlaRace = npcAla.hr;
	nSed = npcSed.hn;
	nSedRace = npcSed.hr;
	nCal = npcCal.hn;
	nCalRace = npcCal.hr;
	nIzu = npcIzu.an; -- leave this, should be opposite cuz it's a foe
	nIzuRace = npcIzu.ar; -- leave this, should be opposite cuz it's a foe
end
if (GetUnitName("player") == nAla) then
	sameFacMsg = 1;
end
SCcheckpoint = 0;
SCPartyBuns = 0;
SCPartyRats = 0;
SCPartyFrogs = 0;
SCCritterKills = 0;
pGhost = "."
SCisRes = 0;
SCres = "";
SCrpt = 0;
SCdetail1, SCdetail2 = nil, nil;
SCdetail1set, SCdetail2set = 0, 0;

-- #######################################################
-- initializeMarauderVars functions
-- #######################################################
function zeroVotes()
	SCVote1, SCVote2, SCVote3, SCVote4 = 0, 0, 0, 0;
end

function initializeMarauderVars()
	--Quest vars
	SCrune, SCdal1, SCviol, SCund, SCring = 0, 0, 0, 0, 0;
	SCgroupname = "";													-- Party's chosen name
	SCpName1, SCpName2, SCpName3, SCpName4 = "", "", "", "";			-- Party member names (string)
	SCcheckpoint = 10;													-- Logic flow variable (number)
	SCCurrQuest = "q0a";												-- For display in Quest Log (string)
	SCMerch1Tlk, SCMerch2Tlk, SCMerch3Tlk = 0, 0, 0;					-- Whether each merchant has been talked to (0 or 1)
	SCMerchantClues = 0; 												-- How many group has achieved (number)
	SCMerchants = 0; 													-- How many this player has spoken to (number)
	zeroVotes();
	SCLastDamager = "";													-- last source name to damage a critter, used for pet kill credit
	SCPartyBuns, SCPartyRats, SCPartyFrogs = 0, 0, 0; 					-- how many of each the party has killed
	SCCritterKills = 0;													-- how many critters of all kinds the party has killed
	SCDoneBun = 0; 														-- Group killed 3 bunnies or squirrels
	SCDoneRats = 0; 													-- Group killed 3 rats
	SCEmoted = 0; 														-- How many got it right
	SCDuelWon = 0;														-- Locally record if a player has won a duel (0 or 1)
	SCDuels = 0;														-- Accumulator for number of party duel victories (number)
	SCSharked = 0;														-- Whether a player has been killed by shark yet (0 or 1)
	--for leadership ranking
	SCchoices = {};
	SCchoiceA, SCchoiceB, SCchoiceC, SCchoiceD = "", "", "", "";
	SCrankA, SCrankB, SCrankC, SCrankD = 0, 0, 0, 0;
	SCrankings = "";
	SCrpt = 1;
	WatchFrame:Hide(); --Hide the Blizzard Quest Tracker
	--the following two get in the way of the addon quest tracker:
	MultiBarLeft:Hide(); --Hide the Blizzard Right-screen Action Bar 1
	MultiBarRight:Hide(); --Hide the Blizzard Right-screen Action Bar 2
	--Leave chat channels
	LeaveChannelByName("Trade");
	LeaveChannelByName("LookingForGroup");
	LeaveChannelByName("General");
	LeaveChannelByName("LocalDefense");

	--UI Variables
	Marauder:Hide(); -- overhead text
	MarauderRing:Hide();
	MarauderBook:Hide();
	MarauderTracker:Hide(); -- quest tracker
	MarauderTracker.q1a.text:Hide();
	MarauderTracker.q1a.check:Hide();
	MarauderTracker.q1b.text:Hide();
	MarauderTracker.q1b.check:Hide();
	MarauderTracker.q1c.text:Hide();
	MarauderTracker.q1c.check:Hide();
	MarauderTracker.q1d.text:Hide();
	MarauderTracker.q1d.check:Hide();
	MarauderTracker.q1e.text:Hide();
	MarauderTracker.q1e.check:Hide();
	MarauderTracker.q1f.text:Hide();
	MarauderTracker.q1f.check:Hide();
	MarauderTracker.q1g.text:Hide();
	MarauderTracker.q1g.check:Hide();
	MarauderTracker.q1h.text:Hide();
	MarauderTracker.q1h.check:Hide();
	MarauderTracker.q1i.text:Hide();
	MarauderTracker.q1i.check:Hide();
	MarauderTracker.q2a.text:Hide();
	MarauderTracker.q2a.check:Hide();
	MarauderTracker.q2b.text:Hide();
	MarauderTracker.q2b.check:Hide();
	MarauderTracker.q2c.text:Hide();
	MarauderTracker.q2c.check:Hide();
	MarauderTracker.q2d.text:Hide();
	MarauderTracker.q2d.check:Hide();
	MarauderTracker.q2e.text:Hide();
	MarauderTracker.q2e.check:Hide();
	MarauderTracker.q2f.text:Hide();
	MarauderTracker.q2f.check:Hide();
	MarauderTracker.q2g.text:Hide();
	MarauderTracker.q2g.check:Hide();
	MarauderTracker.q3a.text:Hide();
	MarauderTracker.q3a.check:Hide();
	MarauderTracker.q3b.text:Hide();
	MarauderTracker.q3b.check:Hide();
	MarauderTracker.q3c.text:Hide();
	MarauderTracker.q3c.check:Hide();
	MarauderTracker.q3d.text:Hide();
	MarauderTracker.q3d.check:Hide();
	MarauderTracker.q3e.text:Hide();
	MarauderTracker.q3e.check:Hide();
	MarauderTracker.title4:Hide();
	MarauderTracker.q4a.text:Hide();
	MarauderTracker.q4a.check:Hide();
	MarauderScreenText:SetText(" ");
	clearVote(); -- hides the tabard voting screen
	MSurveyFrame.va1:Hide();
	MSurveyFrame.va2:Hide();
	MSurveyFrame.va3:Hide();
	MSurveyFrame.va4:Hide();
	MSurveyFrame.vb1:Hide();
	MSurveyFrame.vb2:Hide();
	MSurveyFrame.vb3:Hide();
	MSurveyFrame.vb4:Hide();
	MSurveyFrame.vc1:Hide();
	MSurveyFrame.vc2:Hide();
	MSurveyFrame.vc3:Hide();
	MSurveyFrame.vc4:Hide();
	MSurveyFrame.vd1:Hide();
	MSurveyFrame.vd2:Hide();
	MSurveyFrame.vd3:Hide();
	MSurveyFrame.vd4:Hide();
	--and just in case one of the participants is a toon who has been through it before (testing?),
	--or in case the researcher is trying to use /run sendReset() to mov backwards, reset these to default
	MarauderTracker.q1b.text:SetText("Vermin for Supper (0/3)"); -- for tracking bunnies
	MarauderTracker.q1c.text:SetText("The Talk About Town (0/3)"); -- for tracking merchant clues
	MarauderTracker.q2f.text:SetText("I Smell a Turtle... Er, Rat (0/4)"); -- for tracking frogs and rats
	MarauderTracker.q3a.text:SetText("Come Out Swingin' (0/" .. GetNumPartyMembers() .. ")"); -- for tracking duels

end







-- #######################################################
-- OnUpdate listener
-- #######################################################

local UpdateFrame = CreateFrame("Frame");
UpdateFrame.name = "MarauderUpdateEventFrame";
UpdateFrame:SetScript("OnUpdate", function(self,elapsed)
	-- Fix the discontinuity/coords bug crossing between mainstreet Dalaran and the Underbelly
	if (closeEnough(0, 0, 0) == 1) then
		ToggleFrame(WorldMapFrame);
		ToggleFrame(WorldMapFrame);
	end;
end);


-- #######################################################
-- tallyVotes function for tabard voting
-- #######################################################
function tallyVotes(pl1, pl2, pl3, pl4)
	--trace("tallyVotes function was called by the researcher addon in response to getting a single player vote");
	--Display results of all voters on researcher's overhead display (2 players on a line to fit in overhead)
	--Note that the researcher is not allowed to vote (won't send the message that triggers the logic)
	--So do vote testing from the "player" machine if dual-boxing...
	--THIS logic block functions for the researcher's addon only (it's a function that's called locally by the researcher)

	if (GetNumPartyMembers() == 0) then -- solo, no group
		--Should really be testing this with a group, but...
		--trace("Entered the tallyVotes function, but you're not in a group...");
		AddToOverhead("nobody to gather votes from...");

	elseif (GetNumPartyMembers() == 1) then -- dual box testing
		--Only one player, OK not to check whether all have voted
		--trace("should be printing out 1 vote overhead");
		if (SCVote1 == 8) then
			AddToOverhead(pl1 .. ": " .. SCVote1 .. "\nSuccess!");
			--trace("The one testing player chose the correct tabard, send CORRECT command");
			SendAddonMessage("SRv1", "CORRECT", "PARTY");
		else
			--trace("Players not agreeing, send INCORRECT command");
			AddToOverhead(pl1 .. ": " .. SCVote1);
			SendAddonMessage("SRv1", "INCORRECT", "PARTY");
		end;

	elseif ((GetNumPartyMembers() == 2) and (SCVote1 ~= 0) and (SCVote2 ~= 0)) then
		--Playtesting with 3: 2 party members, and both have voted (neither of the two are nil)
		--trace("should be printing out two votes overhead");
		if ((SCVote1 == 8) and (SCVote2 == 8)) then
			AddToOverhead(pl1 .. ": " .. SCVote1 .. " ... " .. pl2 .. ": " .. SCVote2 .. "\nSucess!");
			--trace("Both players agreed on the correct tabard, send CORRECT command");
			SendAddonMessage("SRv1", "CORRECT", "PARTY");
		else
			--trace("Players not agreeing, send INCORRECT command");
			AddToOverhead(pl1 .. ": " .. SCVote1 .. " ... " .. pl2 .. ": " .. SCVote2);
			SendAddonMessage("SRv1", "INCORRECT", "PARTY");
		end;

	elseif ((GetNumPartyMembers() == 3) and (((SCVote1 ~= 0) and (SCVote2 ~= 0)) or ((SCVote1 ~= 0) and (SCVote3 ~= 0)) or ((SCVote2 ~= 0) and (SCVote3 ~= 0)))) then
		--Playing with 4: 3 party members, short one, and at least 2 have voted
		--trace("should be printing out three votes overhead");
		if ((SCVote1 == 8) and (SCVote2 == 8) and (SCVote3 == 8)) then
			AddToOverhead(pl1 .. ": " .. SCVote1 .. " ... " .. pl2 .. ": " .. SCVote2 .. "\n" .. pl3 .. ": " .. SCVote3 .. "\nSuccess!");
			--trace("All 3 players agreed on the correct tabard, send CORRECT command");
			SendAddonMessage("SRv1", "CORRECT", "PARTY");
		elseif (((SCVote1 == 8) and (SCVote2 == 8)) or ((SCVote2 == 8) and (SCVote3 == 8)) or ((SCVote1 == 8) and (SCVote3 == 8))) then
			--2 of the 3 voting correctly but the other one lagging or not participating
			SendAddonMessage("SRv1", "INCOMPLETE", "PARTY");
		else
			--trace("Players not agreeing, send INCORRECT command");
			AddToOverhead(pl1 .. ": " .. SCVote1 .. " ... " .. pl2 .. ": " .. SCVote2 .. "\n" .. pl3 .. ": " .. SCVote3);
			SendAddonMessage("SRv1", "INCORRECT", "PARTY");
		end;

	elseif ((GetNumPartyMembers() == 4) and (((SCVote1 ~= 0) and (SCVote2 ~= 0) and (SCVote3 ~= 0)) or ((SCVote2 ~= 0) and (SCVote3 ~= 0) and (SCVote4 ~= 0)) or ((SCVote1 ~= 0) and (SCVote2 ~= 0) and (SCVote4 ~= 0)) or ((SCVote1 ~= 0) and (SCVote3 ~= 0) and (SCVote4 ~= 0)))) then
		--Playing with a full party: 4 party members, and at least 3 have voted
		--trace("should be printing out four votes overhead");
		if ((SCVote1 == 8) and (SCVote2 == 8) and (SCVote3 == 8) and (SCVote4 == 8)) then
			AddToOverhead(pl1 .. ": " .. SCVote1 .. " ... " .. pl2 .. ": " .. SCVote2 .. "\n" .. pl3 .. ": " .. SCVote3 .. " ... " .. pl4 .. ": " .. SCVote4 .. "\nSuccess!");
			--trace("3 out of 4 dentists surveyed agreed on the correct tabard, send CORRECT command");
			SendAddonMessage("SRv1", "CORRECT", "PARTY");
		elseif ((SCVote1 == 8) and (SCVote2 == 8) and (SCVote3 == 8)) or ((SCVote2 == 8) and (SCVote3 == 8) and (SCVote4 == 8)) or ((SCVote1 == 8) and (SCVote2 == 8) and (SCVote4 == 8)) or ((SCVote1 == 8) and (SCVote3 == 8) and (SCVote4 == 8)) then
			--3 of the 4 voting correctly but the other one lagging or not participating
			SendAddonMessage("SRv1", "INCOMPLETE", "PARTY");
		else
			--trace("Players not agreeing, send INCORRECT command");
			AddToOverhead(pl1 .. ": " .. SCVote1 .. " ... " .. pl2 .. ": " .. SCVote2 .. "\n" .. pl3 .. ": " .. SCVote3 .. " ... " .. pl4 .. ": " .. SCVote4);
			SendAddonMessage("SRv1", "INCORRECT", "PARTY");
		end;

	else
		--trace("Submitted a button click, but apparently not everyone has voted yet so no overhead display or correct/incorrect message");
		--trace("Check matching logic of number in party and VoteX variables");
	end;
end;
-- #######################################################



local ListenFrame = CreateFrame("Frame");
ListenFrame:RegisterEvent("CHAT_MSG_ADDON");

ListenFrame:SetScript("OnEvent", function(self, event, prefix, msg, channel, sender)

	--##############################################################
	--Researcher-initiated messages (by button click)
	--##############################################################
	if (prefix == "SRRv1") then --> registering the participant researcher's avatar name
		SCres = sender;
		--print("For testing only: " .. SCres .. " is the participant researcher in the party")

	elseif (prefix == "SReset") then
		setSCcheckpoint(tonumber(msg));

	elseif ((prefix == "SCver") and (SCisRes == 1)) then
		trace("|cffff8000Marauder|r: v." .. msg .. "|r -- "..sender);

	elseif (prefix == "SRNAME") then
		trace("|cffff8000The Picaroon Protectorate welcomes the group |r" .. msg);
		SCgroupname = msg;

	elseif (prefix == "SRCLUE") then
		SCcode = msg;

	elseif ((prefix == "SCQUESTS") and (SCisRes == 1)) then
		--send quest accepts and completes to researcher, who will then echo to any logged on guild members with Marauder installed
		--trace("|cffff8000" .. sender .. "|r " .. msg);
		local SCfwd = sender .. "#" .. msg;
		SendAddonMessage("SCGUILDECHO", SCfwd, "GUILD")

	elseif ((prefix == "SCGUILDECHO") and (SCisRes ~= 1)) then
		--don't echo these to researcher
		local playername, questevent = strsplit("#", msg, 2);
		trace("|cffff8000" .. playername .. "|r " .. " " .. questevent);

	elseif ((prefix == "SCSHORTYELL") and ((GetUnitName("player") == "Vaas") or (GetUnitName("player") == "Izuna") or (GetUnitName("player") == "Izunai"))) then
		--for testing only; will be sent to log instead
		--trace("Got yell report from " .. sender .. ": " .. msg);
		local output = "Y#" .. sender .. "#" .. msg .. "\r"
		sendToOffFacResearcherLogger(output, "chatAndEvents", SCSourceBaddie)

	elseif ((prefix == "SCSHORTEMO") and ((GetUnitName("player") == "Vaas") or (GetUnitName("player") == "Izuna") or (GetUnitName("player") == "Izunai"))) then
		--for testing only; will be sent to log instead
		--trace("Got emote report from " .. sender .. ": " .. msg);
		--local output = "E#" .. sender .. "#" .. msg .. "\r"
		sendToOffFacResearcherLogger(msg, "chatAndEvents", SCSourceBaddie)

	elseif ((prefix == "SCSHORTCUSTEMO") and ((GetUnitName("player") == "Vaas") or (GetUnitName("player") == "Izuna") or (GetUnitName("player") == "Izunai"))) then
		--for testing only; will be sent to log instead
		--trace("Got custom emote report from " .. sender .. ": " .. msg);
		--local output = "CE#" .. sender .. "#" .. msg .. "\r"
		sendToOffFacResearcherLogger(msg, "chatAndEvents", SCSourceBaddie)

	--this is the polling for same-faction (Aladriaa) and off-faction observers, not for players
	elseif (((prefix == "pollfwd") and (SCisRes ~= 1)) or ((prefix == "poll") and (channel == "GUILD") and (GetUnitName("player") ~= "Izuna") and (GetUnitName("player") ~= "Izunai")) or ((prefix == "poll") and ((channel == "WHISPER") and ((sender == "Izuna") or (sender == "Izunai"))))) then
		--print("got as far as entering the poll prefix listener on Marauder.lua")
		if (GetUnitName("Player") == nAla) then
			if (SCsamelogs == 0) then
				trace("|cffff8000Marauder|r: started sending position logs to " .. nSed);
				SCsamelogs = 1
			end
		elseif (prefix ~= "pollfwd") then
			SClisteners = 1;
			SCSourceBaddie = sender;
			if (SCofflogs == 0) then
				trace("|cffff8000Marauder|r: started sending position logs to " .. SCSourceBaddie);
				SCofflogs = 1
			end
		end

		local facing = GetPlayerFacing()
		local zone = GetZoneText("player")
		local subzone = GetSubZoneText("player")
		local speed = GetUnitSpeed("player")
		local movement = ""

		if speed == 7 then
			movement = "Normal running"
		elseif speed == 2.5 then
			movement = "Walking"
		elseif speed == 4.5 then
			movement = "Running backwards"
		elseif speed == 26.6 then
			movement = "Epic flying mount"
		elseif speed == 4.7222199440002 then
			movement = "Swimming"
		elseif speed == 0 then
			movement = "Still"
		else
			movement = "unknown"
		end

		local unitX, unitY = GetPlayerMapPosition("player")
		local output = "P#" .. msg .. "#" .. GetUnitName("player") .. "#" .. subzone .. "#" ..tostring(unitX) .. "#" .. tostring(unitY) .. "#0.0#" .. facing .. "#" .. movement .. "\r"
		--print("call sendToOffFacResearcherLogger in the poll section of Marauder.lua listener")
		if (sameFacMsg == 1) then
			SendAddonMessage("log", output, "WHISPER", nSed);
		else
			sendToOffFacResearcherLogger(output, "chatAndEvents", sender)
		end

		--to fix
		--elseif ((prefix == "ALACHAT") and ((UnitName("player") == "Seddrik") or (UnitName("player") == "Sedrick")) then
			--echo chat from Aladria to log
			--local output = "
			--sendToResearcherLogger..

	elseif ((prefix == "SCRANK") and (SCisRes == 1)) then
		trace("|cffff8000" .. sender .. " voted: |r" .. msg);

	elseif (prefix == "SRv1") then --> came from the researcher's addon sent to the party
		--trace("got researcher directive");
		--print(string.format("Received directive from Researchers: [%s] [%s]: %s %s", channel, sender, prefix, msg));

		if msg == "INIT" then
			--trace("Received INIT command");
			--ToDo: make changes to default UI recoverable at the end (check to see if these are set, and put them back if so)
			--ToDo: add an "away message" function that will also be disabled at the end
			--report back to researcher that addon is properly installed and working (and whether researcher flag is set)
			SCres = sender;
			if SCrpt == nil then
				SCrpt = "";
			end
			if ((SCisRes == 0) or (SCisRes == nil)) then
				if (SCrpt == 1) then
					SendAddonMessage("SCver", SCversion.." (PLAYER) [repeating quest on this computer]", "PARTY");
				elseif ((SCrpt == 0) or (SCrpt == "")) then
					SendAddonMessage("SCver", SCversion.." (PLAYER)", "PARTY");
				end
			elseif (SCisRes == 1) then
				SendAddonMessage("SCver", SCversion.." (RESEARCHER)", "PARTY");
			end;
			initializeMarauderVars();

		elseif ((msg == "RING") and (GetSubZoneText() == "Violet Stand")) then
			--researcher makes the ring visible... it will stay visible for the rest of the quest
			MarauderRing:Show();
			MarauderRingVisible = true;
			if (SCisRes == 0) then
				SCcheckpoint = 20;
			end

		elseif ((msg == "CUT-1") and (GetSubZoneText() == "Violet Stand")) then
			--displays book icon to access quest log
			--trace("Received WHISPER command");
			SCcheckpoint = 40;
			ChatWhisper2(nAla, "A'hoy thar! I be ", nAla, "... I'll be steering this ship. Savvy?");
			ChatWhisper(nAla, "The Picaroon Protectorate is glad to have ye swabs on board.");
			transition000Handler(); --the delay animation to allow the above text to be read for a few seconds, then lead into cutscene

		elseif (msg == "STEALME") then
			PlaySound("Stealth", "Master");

		elseif (msg == "ASSASSIN") then
			rogueSoundLauncher(0);

		elseif ((msg == "GO") and ((GetSubZoneText() == "Violet Stand") or (GetSubZoneText() == "Forlorn Woods") or (GetSubZoneText() == "The Twilight Rivulet"))) then
			--trace("Received GO command");
			if (SCisRes == 1) then
				AddToOverhead(ScreenTxt.line0015);
				--AND (as of 3.1.9) triggers next quest manually for the researcher, who doesn't need to click ring near librarian
				AddToQuestWindow("Librarian Belleford", "offer", q1a.Title, q1a.OffTop, q1a.OffBot);
				SCCurrQuest = "q1a";
				SCcheckpoint = 100;
				--Tracker: display text for quest 1a
				MarauderTracker.q1a.text:Show();
			else
				SCcheckpoint = 90;
			end

		elseif ((msg == "INCOMPLETE") and (SCisRes == 0)) then
			--trace("received the INCOMPLETE mesage from researcher addon for tabard voting");
			--Generated by all but one getting the right choice but one not voting at all
			--Don't reset anything, but send a message to the overhead letting them know that one player hasn't voted
			AddToOverhead(ScreenTxt.line0093);

		elseif ((msg == "INCORRECT") and (SCisRes == 0)) then
			--trace("received the INCORRECT message from researcher addon for tabard voting");
			--Generated by the majority of the group voting but selecting different icons (not agreeing)
			--Message (overhead) from Aladriaa telling them it's wrong, and that they have to re-vote
			--Researcher doesn't get this message, since it would overwrite the vote summary overhead
			AddToOverhead(ScreenTxt.line0095);
			--Also re-set the vote variables so that everyone has to vote again, rather than just one person changing their vote
			zeroVotes(); -- same function called with INIT to initialize them all to zero

		elseif (msg == "CORRECT") then
			--Generated by the majority of the group selecting the correct tabard icon
			--trace("Received CORRECT command from researcher addon for tabard voting");
			SCcheckpoint = 210;
			clearVote();
			AddToQuestWindow(nAla, "complete", q1d.Title, q1d.CompTop);
			--Tracker: completed quest 1d
			MarauderTracker.q1d.check:Show();

		elseif (msg == "TRADED") then
			--The party has successfully given the items to Calliopeia
			SCcheckpoint = 310;
			ChatWhisper(nCal, WhisperTxt.line0081);
			AddToQuestWindow(nCal, "complete", q1h.Title, q1h.CompTop);
			--Tracker: complete quest 1h
			MarauderTracker.q1h.check:Show();

		elseif (msg == "REPORT-1") then
			--After talking to Calliopeia, they're prompted to report their findings. This message comes from the REPORT-1 button saying that the report was accepted
			--This is the message from the button pressed by the researcher indicating that Aladriaa's first requested report was accepted
			--trace("Received REPORT-1 command");
			AddToQuestWindow(nAla, "complete", q1i.Title, q1i.CompTop);
			SCachieve(AchTxt.p2);
			SCWhoClue = "Tesla coil tabard\n     Ninja Mechanical Society";
			MQLLeftFrameScrollFrameScrollChildFrameClues3:Show();
			SCcheckpoint = 340;
			--Tracker: complete quest 1i
			MarauderTracker.q1i.check:Show();

		elseif (msg == "ZAP") then
			--trace("Received ZAP command");
			zapMe();

		elseif (msg == "BRIBED") then
			--successfully bribed Calliopeia
			AddToQuestWindow(nCal, "complete", q2a.Title, q2a.CompTop);
			SCcheckpoint = 370;
			--Tracker: complete quest 2a
			MarauderTracker.q2a.check:Show();

		--elseif (msg == "CODE") then
			--successfully solved code -- this is the version sent by the researcher button
			--NOW (3.1.9) this will be automated by the chat listener matching at SCcheckpoint 390

		elseif (msg == "SEWERKILL") then
			--manually set completion of rat/frog task in case something goes wrong
			local critters = 4;
			local newqtext = (string.gsub(qtext,"(.*)%((.)%/4%)", "%1%("..critters.."\/4%)", 1))
			MarauderTracker.q2f.text:SetText(newqtext);
			AddToQuestWindow("Jindall", "complete", q2f.Title, q2f.CompTop);
			ChatWhisper("Jindall", WhisperTxt.line0091);
			SCcheckpoint = 540;
			--Tracker: completed quest 2f
			MarauderTracker.q2f.check:Show();

		elseif (msg == "REPORT-2") then
			--trace("Received REPORT command");
			AddToQuestWindow(nAla, "complete", q2g.Title, q2g.CompTop);
			SCachieve(AchTxt.p3);
			SCWhatClue = "Building a machine\n     to bring down Dalaran";
			MQLLeftFrameScrollFrameScrollChildFrameClues4:Show();
			SCcheckpoint = 570;
			--Tracker: complete quest 2g
			MarauderTracker.q2g.check:Show();

		elseif (msg == "REPORT-3") then -- Aladriaa accepts the players' report after cutscene 2
			--trace("Received REPORT command");
			AddToQuestWindow(nAla, "complete", q3d.Title, q3d.CompTop);
			SCachieve(AchTxt.p4);
			SCHowClue = "The machine runs on magic...\n     Use magic to stop it";
			MQLLeftFrameScrollFrameScrollChildFrameClues5:Show();
			SCcheckpoint = 720;
			--Tracker: complete quest 3d
			MarauderTracker.q3d.check:Show();

		elseif (msg == "MOBS") then
			--Researcher button, so the researcher can wait until the NPC is ready to spring
			--trace("Received MOBS command");
			SCcheckpoint = 770;
			AddToOverheadQuick(ScreenTxt.line0125); --announces the boss' warcry outside the pink circle
			PlaySoundFile("Interface\\AddOns\\Marauder\\Sounds\\bossBattleYell.mp3");

		elseif (msg == "BOSS") then
			--Manually triggered after the low-level opponents are defeated, signaling time for boss to join
			SCcheckpoint = 810;
			AddToOverhead(ScreenTxt.line0145); --fight's not over yet

		elseif (msg == "BOOM") then
			--received BOOM command, triggers cutscene 3
			SCcheckpoint = 820;
			transition300Handler();

		--elseif msg == "(%a+)||(%a+)||(%a+)||(%a+)" then
		elseif (msg == "LEADER") then
			--trace("received LEADER command, starting leadership voting");
			SCcheckpoint = 850;
			SCres = sender;
			--Do a fresh name check, just in case someone crashed out, etc...
			SCpName0 = GetUnitName("player");
			SCpName1 = GetUnitName("party1");
			SCpName2 = GetUnitName("party2");
			SCpName3 = GetUnitName("party3");
			if GetNumPartyMembers() == 4 then
				SCpName4 = GetUnitName("party4");
			else
				SCpName4 = nil;
			end
			--Make sure the variables are nil and the table is empty before the following logic
			SCchoiceA = nil;
			SCchoiceB = nil;
			SCchoiceC = nil;
			SCchoiceD = nil;
			for i = 1, #SCchoices do
				table.remove(SCchoices, i);
			end
			--Uses the SCres variable (refreshed in this function, not set during INIT) to populate all the non-researcher player names for the choices to vote for
			if SCpName0 ~= SCres then
				table.insert(SCchoices, SCpName0)
			end
			if ((SCpName1 ~= nil) and (SCpName1 ~= SCres)) then
				table.insert(SCchoices, SCpName1);
			--MQuestFrame.LdrButton1:Show(); -- each of these
			end
			if ((SCpName2 ~= nil) and (SCpName2 ~= SCres)) then
				table.insert(SCchoices, SCpName2);
			--MQuestFrame.LdrButton2:Show();
			end
			if ((SCpName3 ~= nil) and (SCpName3 ~= SCres)) then
				table.insert(SCchoices, SCpName3);
			--MQuestFrame.LdrButton3:Show();
			end
			if ((SCpName4 ~= nil) and (SCpName4 ~= SCres)) then
				table.insert(SCchoices, SCpName4);
			--MQuestFrame.LdrButton4:Show();
			end
			SCchoiceA = SCchoices[1];
			SCchoiceB = SCchoices[2];
			SCchoiceC = SCchoices[3];
			SCchoiceD = SCchoices[4];
			AddToRankWindow("Leadership Ranking", q4b.Title, q4b.VoteTop, SCchoiceA, SCchoiceB, SCchoiceC, SCchoiceD)

		elseif (msg == "DONE") then
			--trace("recieved the DONE command from researcher");
			SCcheckpoint = 860;
			MarauderTracker:Hide();
			Marauder:Hide(); -- overhead text
			MarauderRing:Hide();
			MarauderBook:Hide();
			theEndTitle();
			--and tie that graphic's close handler to clean up changes that have been made to the interface

		elseif (msg == "STATUS") then
			local playertype = "";
			--trace("received the STATUS command from researcher");
			if (SCisRes == 1) then
				playertype = "researcher";
			elseif ((SCisRes == 0) or (SCisRes == nil)) then
				playertype = "player";
			end;
			local values = "Status for " .. GetUnitName("player") .. ": SCCurrQuest " .. SCCurrQuest .. "; SCcheckpoint " .. tostring(SCcheckpoint) .. "; (" .. playertype .. ")"
			SendAddonMessage("SC2Rv1", values, "PARTY");

		elseif (msg == "ACH1") then
			SCachieve(AchTxt.a1a, AchTxt.a1b)
			--local timeString = calcHoursMinSec();
			--local output = "ACH#" .. timeString .. "#" .. UnitName("Player") .. "#got achievement#" .. AchTxt.a1a .. "\r";
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. AchTxt.a1a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH2") then
			SCachieve(AchTxt.a2a, AchTxt.a2b)
			--local timeString = calcHoursMinSec();
			--local output = "ACH#" .. timeString .. "#" .. UnitName("Player") .. "#got achievement#" .. AchTxt.a2a .. "\r";
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. AchTxt.a2a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH3") then
			SCachieve(AchTxt.a3a, AchTxt.a3b)
			--local timeString = calcHoursMinSec();
			--local output = "ACH#" .. timeString .. "#" .. UnitName("Player") .. "#got achievement#" .. AchTxt.a3a .. "\r";
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. AchTxt.a3a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH4") then
			SCachieve(AchTxt.a4a, AchTxt.a4b)
			--local timeString = calcHoursMinSec();
			--local output = "ACH#" .. timeString .. "#" .. UnitName("Player") .. "#got achievement#" .. AchTxt.a4a .. "\r";
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. AchTxt.a4a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH5") then
			SCachieve(AchTxt.a5a, AchTxt.a5b)
			--local timeString = calcHoursMinSec();
			--local output = "ACH#" .. timeString .. "#" .. UnitName("Player") .. "#got achievement#" .. AchTxt.a5a .. "\r";
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. AchTxt.a5a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH6") then
			SCachieve(AchTxt.a6a, AchTxt.a6b)
			--local timeString = calcHoursMinSec();
			--local output = "ACH#" .. timeString .. "#" .. UnitName("Player") .. "#got achievement#" .. AchTxt.a6a .. "\r";
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. AchTxt.a6a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH7") then
			SCachieve(AchTxt.a7a, AchTxt.a7b)
			--local timeString = calcHoursMinSec();
			--local output = "ACH#" .. timeString .. "#" .. UnitName("Player") .. "#got achievement#" .. AchTxt.a7a .. "\r";
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. AchTxt.a7a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH8") then
			SCachieve(AchTxt.a8a, AchTxt.a8b)
			--local timeString = calcHoursMinSec();
			--local output = "ACH#" .. timeString .. "#" .. UnitName("Player") .. "#got achievement#" .. AchTxt.a8a .. "\r";
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. AchTxt.a8a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH9") then
			SCachieve(AchTxt.a9a, AchTxt.a9b)
			--local timeString = calcHoursMinSec();
			--local output = "ACH#" .. timeString .. "#" .. UnitName("Player") .. "#got achievement#" .. AchTxt.a9a .. "\r";
			local output = "ACH#" .. GetUnitName("Player") .. "#got achievement#" .. AchTxt.a9a .. "\r";
			sendToResearcherLogger(output);

		elseif (msg == "ACH13") then
			--No longer an achievement button... enable the participant code (no longer load on demand of a separate addon)
			if (SCinitializedParticipant == 1) then
				SendAddonMessage("SC2Rv1", "LOADEDALREADY", "PARTY");
			elseif (SCinitializedParticipant == 0) then
				initializeParticipantSection()
				trace("|cffff8000Marauder|r: initialized for quest by " .. sender)
				MarauderHat:Show();
				SendAddonMessage("SC2Rv1", "LOADED", "PARTY");
				local output = "LD#" .. GetUnitName("Player") .. "#loaded MParticipant, MarauderVersion: " .. SCversion .. ":" .. SCrpt .. "\r";
				sendToResearcherLogger(output);
			else
				--probably means that SCinitializedParticipant is nil, which means something didn't load properly
				trace("|cffff8000Marauder|r: MarauderParticipant error 999")
			end
		end



	--##############################################################
	--Player-initiated messages to players (driven by events)
	--##############################################################



	elseif (prefix == "SCv1") then --> came from other players' addon
		--trace("got player report");
		--print(string.format("Received report from other player: [%s] [%s]: %s %s", channel, sender, prefix, msg));


		if (msg == "AXE") then
			-- Talking to Axechewer (triggered by ring click with whole party nearby)
			AddToQuestWindow(nAxe, "complete", q1a.Title, q1a.CompTop);
			SCcheckpoint = 120;
			--Tracker: complete quest 1a
			MarauderTracker.q1a.check:Show();

		elseif ((msg == "BUNNYKILL") or (msg == "BUNNYKILLPET")) then
			-- Fires each time a rabbit is killed (triggered by combat listener)
			local killer = "";
			if (msg == "BUNNYKILL") then
				killer = sender;
			elseif (msg == "BUNNYKILLPET") then
				killer = sender .. "'s pet";
			end
			SCPartyBuns = SCPartyBuns + 1;
			SCCritterKills = SCCritterKills + 1
			PlaySoundFile("Interface\\AddOns\\Marauder\\Sounds\\machineComplete_0.mp3");
			if (SCcheckpoint == 140) then
				AddToOverhead(killer .. " killed a bunny (" .. SCPartyBuns .. "/3)");
				--Tracker: update quest text for 1b (x/3)
				local qtext = MarauderTracker.q1b.text:GetText();
				--trace("text of q1b retrieved: " .. qtext);
				--Look for pattern of text and (x/3), update with current version of SCPartyBuns for x
				local newqtext = (string.gsub(qtext,"(.*)%((.)%/3%)", "%1%("..SCPartyBuns.."\/3%)", 1))
				MarauderTracker.q1b.text:SetText(newqtext);
				if SCPartyBuns == 3 then
					AddToQuestWindow(nAxe, "complete", q1b.Title, q1b.CompTop);
					SCcheckpoint = 150;
					--Tracker: complete quest 1b
					MarauderTracker.q1b.check:Show();
				end;
			end;

		elseif ((msg == "SQUIRRELKILL") or (msg == "SQUIRRELKILLPET")) then
			-- Fires each time a squirrel is killed (triggered by combat listener)
			local killer = "";
			if (msg == "SQUIRRELKILL") then
				killer = sender
			elseif (msg == "SQUIRRELKILLPET") then
				killer = sender .. "'s pet";
			end
			SCPartyBuns = SCPartyBuns + 1;
			SCCritterKills = SCCritterKills + 1
			PlaySoundFile("Interface\\AddOns\\Marauder\\Sounds\\machineComplete_0.mp3");
			if (SCcheckpoint == 140) then
				AddToOverhead(killer .. " killed a squirrel (" .. SCPartyBuns .. "/3)");
				--Tracker: update quest text for 1b (x/3)
				local qtext = MarauderTracker.q1b.text:GetText();
				--trace("text of q1b retrieved: " .. qtext);
				--Look for pattern of text and (x/3), update with current version of SCPartyBuns for x
				local newqtext = (string.gsub(qtext,"(.*)%((.)%/3%)", "%1%("..SCPartyBuns.."\/3%)", 1))
				MarauderTracker.q1b.text:SetText(newqtext);
				if SCPartyBuns == 3 then
					AddToQuestWindow(nAxe, "complete", q1b.Title, q1b.CompTop);
					SCcheckpoint = 150;
					--Tracker: complete quest 1b
					MarauderTracker.q1b.check:Show();
				end;
			end;

		-- ###########
		-- MERCHANTS
		-- ###########
		elseif (msg == "MERCH1") then
			-- Talking to Merchant1 (Jepetto) (triggered by ring click nearby)
			SCMerch1Tlk = 1;
			SCMerchantClues = SCMerchantClues + 1;
			if (SCMerchantClues == 1) then
				rogueSoundLauncher(2)
			end
			if (SCMerchantClues < 3) then
				AddToOverhead("Jepetto whispered a clue to " .. sender .. "\nin The Wonderworks (" .. SCMerchantClues .. "/3)");
			elseif (SCMerchantClues == 3) then		--done with clue gathering
				SCcheckpoint = 180;
				AddToOverhead("Jepetto whispered a clue to " .. sender .. "\nin The Wonderworks. All the clues have been collected! (3/3)");
				AddToQuestWindow(nAla, "complete", q1c.Title, q1c.CompTop, q1c.ComBot);
				--Tracker: complete quest 1c
				MarauderTracker.q1c.check:Show();
			end;
			--Tracker: update quest text for 1c (x/3) whether it's complete or not
			local qtext = MarauderTracker.q1c.text:GetText();
			--trace("text of q1c retrieved: " .. qtext);
			--Look for pattern of text and (x/3), update with current version of SCMerchantClues for x
			local newqtext = (string.gsub(qtext,"(.*)%((.)%/3%)", "%1%("..SCMerchantClues.."\/3%)", 1))
			MarauderTracker.q1c.text:SetText(newqtext);

		elseif (msg == "MERCH2") then
			-- Talking to Merchant2 (Karadonna) (triggered by ring click nearby)
			SCMerch2Tlk = 1;
			SCMerchantClues = SCMerchantClues + 1;
			if (SCMerchantClues == 1) then
				rogueSoundLauncher(2)
			end
			if (SCMerchantClues < 3) then
				AddToOverhead("Karadonna whispered a clue to " .. sender .. "\nin The Threads of Fate (" .. SCMerchantClues .. "/3)");
			elseif (SCMerchantClues == 3) then		--done with clue gathering
				SCcheckpoint = 180;
				AddToOverhead("Karadonna whispered a clue to " .. sender .. "\nin The Threads of Fate. All the clues have been collected! (3/3)");
				AddToQuestWindow(nAla, "complete", q1c.Title, q1c.CompTop, q1c.ComBot);
				--Tracker: complete quest 1c
				MarauderTracker.q1c.check:Show();
			end;
			--Tracker: update quest text for 1c (x/3) whether it's complete or not
			local qtext = MarauderTracker.q1c.text:GetText();
			--trace("text of q1c retrieved: " .. qtext);
			--Look for pattern of text and (x/3), update with current version of SCMerchantClues for x
			local newqtext = (string.gsub(qtext,"(.*)%((.)%/3%)", "%1%("..SCMerchantClues.."\/3%)", 1))
			MarauderTracker.q1c.text:SetText(newqtext);

		elseif (msg == "MERCH3") then
			-- Talking to Merchant3 (Amisi) (triggered by ring click nearby)
			SCMerch3Tlk = 1;
			SCMerchantClues = SCMerchantClues + 1;
			if (SCMerchantClues == 1) then
				rogueSoundLauncher(2)
			end
			if (SCMerchantClues < 3) then
				AddToOverhead("Amisi whispered a clue to " .. sender .. "\nin The Legerdemain Lounge (" .. SCMerchantClues .. "/3)");
			elseif (SCMerchantClues == 3) then		--done with clue gathering
				SCcheckpoint = 180;
				AddToOverhead("Amisi whispered a clue to " .. sender .. "\nin The Legerdemain Lounge. All the clues have been collected! (3/3)");
				AddToQuestWindow(nAla, "complete", q1c.Title, q1c.CompTop, q1c.ComBot);
				--Tracker: complete quest 1c
				MarauderTracker.q1c.check:Show();
			end;
			--Tracker: update quest text for 1c (x/3) whether it's complete or not
			local qtext = MarauderTracker.q1c.text:GetText();
			--trace("text of q1c retrieved: " .. qtext);
			--Look for pattern of text and (x/3), update with current version of SCMerchantClues for x
			local newqtext = (string.gsub(qtext,"(.*)%((.)%/3%)", "%1%("..SCMerchantClues.."\/3%)", 1))
			MarauderTracker.q1c.text:SetText(newqtext);

		elseif (msg == "GRAVEYARD") then
			AddToQuestWindow("Azukk", "complete", q1e.Title, q1e.CompTop)
			SCcheckpoint = 240;
			--Tracker: complete quest 1e
			MarauderTracker.q1e.check:Show();

		elseif (msg == "FORGE") then
			AddToQuestWindow("Rhudoh", "complete", q1f.Title, q1f.CompTop)
			SCcheckpoint = 270;
			--Tracker: complete quest 1f
			MarauderTracker.q1f.check:Show();

		elseif (msg == "COPPER") then
			AddToOverheadQuick(sender .. " crafted a copper bar!");
			--and the quest is completed at the end of the overhead message's display

		elseif (msg == "WHADDAYAWANT") then
			AddToOverhead(ScreenTxt.line0100);

		elseif (msg == "COIN") then
			AddToOverhead(ScreenTxt.line0105);

		elseif (msg == "SOLVED") then
			AddToQuestWindow(nAla, "complete", q2b.Title, q2b.CompTop);
			MQLLeftFrameScrollFrameScrollChildFrameClues2:Show();
			SCcheckpoint = 400;
			--Tracker:complete quest 2b
			MarauderTracker.q2b.check:Show();

		elseif (msg == "CHALLENGE") then
			--clicking near Azukk, rather than saying code word
			AddToOverhead("You! Speak the code word, or I'll not be sayin' a thing.");

		elseif (msg == "AZUKK") then
			-- Talking to Azukk (triggered by ring click with 420)
			SCcheckpoint = 430;
			AddToQuestWindow("Azukk", "complete", q2c.Title, q2c.CompTop)
			--Tracker: Completed quest 2c
			MarauderTracker.q2c.check:Show();

		elseif (msg == "EMOTED") then
			-- Fires each time a player chooses the proper emote (triggered by emote listener)
			SCEmoted = SCEmoted + 1;
			if (SCEmoted >= GetNumPartyMembers()) then -- >= to account for the possibility of the researcher doing the emote too
				SCcheckpoint = 470;
				AddToQuestWindow("Azukk", "complete", q2d.Title, q2d.CompTop);
				--Tracker: complete quest 2d
				MarauderTracker.q2d.check:Show();
			end;

		elseif (msg == "SEWERS") then
			-- Talking to Jindall (triggered by ring click nearby)
			SCcheckpoint = 500;
			AddToQuestWindow("Jindall", "complete", q2e.Title, q2e.CompTop);
			--Tracker: complete quest 2e
			MarauderTracker.q2e.check:Show();

		elseif ((msg == "RATKILL") or (msg == "RATKILLPET")) then
			-- Fires each time a player kills a rat (triggered by combat listener);
			local killer = "";
			if (msg == "RATKILL") then
				killer = sender
			elseif (msg == "RATKILLPET") then
				killer = sender .. "'s pet";
			end
			SCCritterKills = SCCritterKills + 1
			if (SCPartyRats < 2) then
				SCPartyRats = SCPartyRats + 1;
				AddToOverhead(killer .. " killed a rat (" .. SCPartyRats .. "/2)");
				--Tracker: update quest text for 2f (x/3)
				local qtext = MarauderTracker.q2f.text:GetText();
				--trace("text of q2f retrieved: " .. qtext);
				--Look for pattern of text and (x/4), update with current version of SCPartyRats + SCPartyFrogs for x
				local critters = SCPartyRats + SCPartyFrogs
				local newqtext = (string.gsub(qtext,"(.*)%((.)%/4%)", "%1%("..critters.."\/4%)", 1))
				MarauderTracker.q2f.text:SetText(newqtext);
			end
			if ((SCPartyRats + SCPartyFrogs) == 2) then
				zapMe();
			end
			if ((SCPartyRats == 2) and (SCPartyFrogs == 2)) then
				--done with killing;
				AddToQuestWindow("Jindall", "complete", q2f.Title, q2f.CompTop);
				ChatWhisper("Jindall", WhisperTxt.line0091);
				SCcheckpoint = 540;
				--Tracker: completed quest 2f
				MarauderTracker.q2f.check:Show();
			end;

		elseif ((msg == "FROGKILL") or (msg == "FROGKILLPET")) then
			-- Fires each time a player kills a rat (triggered by combat listener);
			local killer = "";
			if (msg == "FROGKILL") then
				killer = sender
			elseif (msg == "FROGKILLPET") then
				killer = sender .. "'s pet";
			end
			SCCritterKills = SCCritterKills + 1
			if (SCPartyFrogs < 2) then
				SCPartyFrogs = SCPartyFrogs + 1;
				AddToOverhead(killer .. " killed a frog (" .. SCPartyFrogs .. "/2)");
				--Tracker: update quest text for 2f (x/3)
				local qtext = MarauderTracker.q2f.text:GetText();
				--trace("text of q2f retrieved: " .. qtext);
				--Look for pattern of text and (x/4), update with current version of SCPartyRats + SCPartyFrogs for x
				local critters = SCPartyRats + SCPartyFrogs
				local newqtext = (string.gsub(qtext,"(.*)%((.)%/4%)", "%1%("..critters.."\/4%)", 1))
				MarauderTracker.q2f.text:SetText(newqtext);
			end
			if ((SCPartyRats + SCPartyFrogs) == 2) then
				zapMe();
			end
			if ((SCPartyRats == 2) and (SCPartyFrogs == 2)) then
				--done with killing
				AddToQuestWindow("Jindall", "complete", q2f.Title, q2f.CompTop);
				ChatWhisper("Jindall", WhisperTxt.line0091);
				SCcheckpoint = 540;
				--Tracker: completed quest 2f
				MarauderTracker.q2f.check:Show();
			end;

		elseif (msg == "GODUEL") then
			AddToQuestWindow("Apriloneil", "offer", q3a.Title, q3a.OffTop, q3a.OffBot);
			SCcheckpoint = 590;
			--Tracker: offer quest 3a
			MarauderTracker.q3a.text:Show();

		elseif (msg == "DUEL") then
			-- Fires each time a player wins a duel (triggered by chat_msg_system listener)
			local pnum = GetNumPartyMembers(); -- GetNumPartyMembers() returns number of OTHERS in the party
			--So for a full party of 5, this number will be 4, but researcher already doesn't count in the fighting, so this number is OK
			--In other words, in a party of 4 players and a researcher, there must be 4 duel victories.
			SCDuels = SCDuels + 1;
			AddToOverhead(sender .. " won a duel (" .. SCDuels .. "/" .. pnum ..")");
			--Tracker: update text for 3a (x/y)
			local qtext = MarauderTracker.q3a.text:GetText();
			--trace("text of q3a retrieved: " .. qtext);
			--Look for pattern of text and (x/y), update with current version of SCDuels for x and pnum for y
			local newqtext = (string.gsub(qtext,"(.*)%((.)%/.%)", "%1%("..SCDuels.."\/" .. pnum .. "%)", 1))
			MarauderTracker.q3a.text:SetText(newqtext);
			if SCDuels == pnum then
				SCcheckpoint = 610;
				AddToQuestWindow("Apriloneil", "complete", q3a.Title, q3a.CompTop);
				--Tracker: complete 3a
				MarauderTracker.q3a.check:Show();
			end;

		elseif (msg == "DIE") then
			-- A player has found the mage (triggered by ring click near him)
			SCcheckpoint = 640;
			AddToQuestWindow(nAla, "complete", q3b.Title, q3b.CompTop);
			--Tracker: complete quest 3b
			MarauderTracker.q3b.check:Show();

		elseif ((msg == "SHARK") and (SCSharked == 0)) then
			-- A player was killed by the shark (message triggered by combat listener)
			-- With the post-pilot change of quests, this no longer needs to dynamically know the ghost's name for the quest window, so not updating q3c.CompTop any more.
			--pGhost = sender;
			--q3c.CompTop = "" .. pGhost .. " be now as much a ghost as Davy Jones.\n\nAye, we appreciate yer sacrifice, wee one.\n\nNow yer spirit can go back to that mage to see what ye can do.";
			SCSharked = 1;
			SCcheckpoint = 670;
			AddToOverhead(sender .. ScreenTxt.line0115);
			--And this overhead message triggers completion of q3c

		elseif (msg == "CUT2") then
			-- WUM clicked second time, play cutscene 2
			SCCheckpoint = 680;
			transition201Handler();

		elseif (msg == "SPELL") then
			-- A party member clicks the ring to transfer the spell to Aladriaa
			AddToQuestWindow(nAla, "complete", q3e.Title, q3e.CompTop);
			SCcheckpoint = 750;
			--Tracker: complete quest 3e
			MarauderTracker.q3e.check:Show();
		end;


	--##############################################################
	--Player-initiated messages to researcher (driven by events)
	--##############################################################


	elseif ((prefix == "SC2Rv1") and (SCisRes == 1)) then --> came from players sent to researcher for reporting
	--trace("received report from player");
		SCpName1 = GetUnitName("party1");
		SCpName2 = GetUnitName("party2");
		SCpName3 = GetUnitName("party3");
		if GetNumPartyMembers == 4 then
			SCpName4 = GetUnitName("party4"); --may not always have a full group
			--trace("4 other group members: " .. pname1 .. pname2 .. pname3 .. pname4);
		elseif GetNumPartyMembers == 3 then
			--trace("3 other group members: " .. pname1 .. pname2 .. pname3)
			pname4 = nil;
		end;

		if (string.find(msg, "Status") ~= nil) then
			--print out the status report received from the player in response to the /SC status command
			--trace("recieved a status report, should be printing out");
			trace(msg);

		elseif (msg == "LOADED") then
			--report the successful loading of the MarauderParticipant addon
			trace("|cffff8000" .. sender .. "|r successfully initialized MParticipant to begin logging");

		elseif (msg == "LOADEDALREADY") then
			trace("|cffff8000" .. sender .. "|r already initialized MParticipant");

		elseif (msg == "WHISP1") then
			trace("|cffff8000" .. sender .. "|r clicked the ring and got the sound check message");

		elseif (msg == "WHISP2") then
			trace("|cffff8000" .. sender .. "|r clicked the quest book for the first time");

		elseif (msg == "LIB") then
			trace("|cffff8000" .. sender .. "|r clicked the Librarian and got quest.");

		--echo whispers from merchants to researcher
		elseif (msg == "MERCH1") then
			print("|cffff8000" .. sender .. "|r got the clue from Jepetto in The Wonderworks (symmetry)");

		elseif (msg == "MERCH2") then
			print("|cffff8000" .. sender .. "|r got the clue from Karandonna in The Threads of Fate (skies)");

		elseif (msg == "MERCH3") then
			print("|cffff8000" .. sender .. "|r got the clue from Amisi in The Legerdemain Lounge (fire and light)");


		-- ######TABARD VOTING#####################
		--trace("received vote from player");
		elseif msg == "T01" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 1");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				--trace(pname .. ":" .. sender);
				if (pname == sender) then --this is the party member sending the vote
					if i == 1 then -- player party1 sends Vote1
						SCVote1 = 1 --record a vote for tabard 1 from player 1
					elseif i == 2 then
						SCVote2 = 1 --record a vote for tabard 1 from player 2
					elseif i == 3 then
						SCVote3 = 1 --record a vote for tabard 1 from player 3
					elseif i == 4 then
						SCVote4 = 1 --record a vote for tabard 1 from player 4
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T02" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 2");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 2
					elseif i == 2 then
						SCVote2 = 2
					elseif i == 3 then
						SCVote3 = 2
					elseif i == 4 then
						SCVote4 = 2
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T03" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 3");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 3
					elseif i == 2 then
						SCVote2 = 3
					elseif i == 3 then
						SCVote3 = 3
					elseif i == 4 then
						SCVote4 = 3
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T04" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 4");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 4
					elseif i == 2 then
						SCVote2 = 4
					elseif i == 3 then
						SCVote3 = 4
					elseif i == 4 then
						SCVote4 = 4
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T05" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 5");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 5
					elseif i == 2 then
						SCVote2 = 5
					elseif i == 3 then
						SCVote3 = 5
					elseif i == 4 then
						SCVote4 = 5
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T06" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 6");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 6
					elseif i == 2 then
						SCVote2 = 6
					elseif i == 3 then
						SCVote3 = 6
					elseif i == 4 then
						SCVote4 = 6
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T07" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 7");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 7
					elseif i == 2 then
						SCVote2 = 7
					elseif i == 3 then
						SCVote3 = 7
					elseif i == 4 then
						SCVote4 = 7
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T08" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 8");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 8
					elseif i == 2 then
						SCVote2 = 8
					elseif i == 3 then
						SCVote3 = 8
					elseif i == 4 then
						SCVote4 = 8
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T09" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 9");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 9
					elseif i == 2 then
						SCVote2 = 9
					elseif i == 3 then
						SCVote3 = 9
					elseif i == 4 then
						SCVote4 = 9
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T10" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 10");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 10
					elseif i == 2 then
						SCVote2 = 10
					elseif i == 3 then
						SCVote3 = 10
					elseif i == 4 then
						SCVote4 = 10
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T11" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 11");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 11
					elseif i == 2 then
						SCVote2 = 11
					elseif i == 3 then
						SCVote3 = 11
					elseif i == 4 then
						SCVote4 = 11
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		elseif msg == "T12" then
			trace("|cffff8000" .. sender .. "|r voted for Tabard 12");
			for i = 1, GetNumPartyMembers() do
				local pname = GetUnitName("party"..i);
				if (pname == sender) then
					if i == 1 then
						SCVote1 = 12
					elseif i == 2 then
						SCVote2 = 12
					elseif i == 3 then
						SCVote3 = 12
					elseif i == 4 then
						SCVote4 = 12
					end;
				end;
			end;
			tallyVotes(SCpName1, SCpName2, SCpName3, SCpName4);
		-- ##########END OF VOTING##################

		elseif (msg == "END") then
			trace("|cffff8000" .. sender .. "|r reached the end of the quest.");
		end
	end

	--=============================
	--Here is the poll response code taken from Marauder Participant, altered...
	--=============================

	if (channel == "WHISPER") then
		local player = GetUnitName("player")

		if (prefix == "test") then
			local output = player .. "'s logger is enabled, v" .. SCversion .. "."
			if (SCinitializedParticipant == 1) then
				MsendToResearcherLogger(output, "status")
			end


		elseif ((prefix == "poll") and (SClisteners ~= 1)) then

			if ((SCisRes == 1) and (IsInGuild() == 1)) then
				--researcher receives the poll message sent to himself, forwards to his own guild observers, specifically Aladriaa
				--did this rather than having to mess with ScribeResearcher to also send in GUILD
				SendAddonMessage("pollfwd", msg, "GUILD")
			end


			--code below I want to print only once to the log so I will send after the first poll is received
			if (firstPollReceived == 0) then

				--getting snapshot of player demographics and stats
				--UnitName
				local name = UnitName("Player")

				--UnitRace
				local race = UnitRace("Player")

				--UnitClass
				local class =  UnitClass("Player")

				--UnitSex
				local sex = UnitSex("Player")
				local gender = ""
				if sex == 3 then
					gender = "female"
				elseif sex == 2 then
					gender = "male"
				elseif sex == 1 then
					gender = "Unknown"
				end

				money = GetMoney()

				local output = "STATS#" .. UnitName("Player") .. "#race=" .. race .. "#class=" .. class .. "#gender=" .. gender ..  "\r"
				if (SCisRes == 1) then
					SendAddonMessage("stats", output, "WHISPER", GetUnitName("player"))
				elseif (SCinitializedParticipant == 1) then
					MsendToResearcherLogger(output, "stats")
				end
				--print("stats: " .. output)

				-------------------Create bag status #1--------------------------
				--create array used to store items from all bags, need item and #

				-- determining number of bags the player has
				local numBags = 0
				for i = 0, NUM_BAG_SLOTS do
					local name = GetBagName(i)
					if name ~= nil then
						numBags = numBags + 1
					end
				end

				--for each bag, get number of slots, go through each slot and save off itemId and number to bagItemsBefore{}
				for bag = 0, numBags-1 do
					local numSlots = GetContainerNumSlots(bag)

					--filling idTable with unique id values from slots in bags
					for slot = 1, numSlots do

						local id = GetContainerItemID(bag, slot)
						if id ~= nil then
							local itemCount = GetItemCount(id)
							local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(id)
							bagItemsBefore[id]=itemCount
						end
					end
				end

				--print out contents originally in bag

				local output = "BS#" .. UnitName("Player") .. "#"
				--print("bags: " .. output)
				for k,v in pairs(bagItemsBefore) do
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					output = output .. name .. "#" .. v .. "#"
				end
				output = output .. "\r"
				--print("full bag info: " .. output)

				--sending the output in strings of 255 or less if output > 255
				if (#output > 255) then
					local i = 1
					while i < #output do
						if (i ~= 1) then
							outputPart = string.sub(output, i, i+253)
							--first sent part of message, prepend a % to indicate how to format by ScribeResearcher
							outputPart = "%#" .. outputPart
							i = i + 253
						else
							outputPart = string.sub(output, i, i+255)
							i = i+255
						end

						--local outputPart = string.sub(output, i, i+255)
						--i = i+255
						if (SCisRes == 1) then
							SendAddonMessage("bag", outputPart, "WHISPER", GetUnitName("player"))
						elseif (SCinitializedParticipant == 1) then
							MsendToResearcherLogger(outputPart, "bag")
							--self:Print(outputPart)
						end
					end
				else
					if (SCisRes == 1) then
						SendAddonMessage("bag", output, "WHISPER", GetUnitName("player"))
					elseif (SCinitializedParticipant == 1) then
						MsendToResearcherLogger(output, "bag")
					end
				end


				--for scanning inventory

				inventorySlots = {
					"AmmoSlot",
					"HeadSlot",
					"NeckSlot",
					"ShoulderSlot",
					"ShirtSlot",
					"ChestSlot",
					"WaistSlot",
					"LegsSlot",
					"FeetSlot",
					"WristSlot",
					"HandsSlot",
					"Finger0Slot",
					"Finger1Slot",
					"Trinket0Slot",
					"Trinket1Slot",
					"BackSlot",
					"MainHandSlot",
					"SecondaryHandSlot",
					"RangedSlot",
					"TabardSlot",
				}

				-- iterating over inventory slots to get ids, used to check and see what item changed in inventory
				for i = 1, #inventorySlots do
					local slotName = inventorySlots[i]
					local id, texture, checkRelic = GetInventorySlotInfo(slotName)
					local itemId = GetInventoryItemID("Player", id)
					if (itemId == nil) then
						itemId = 0
					end
					table.insert(equippedItems, itemId)
				end
				--testing... print out the item IDs for all initially equipped things (confirmed works in v3.2.17)
				--for i = 1, #equippedItems do
					--print(equippedItems[i])
				--end
				firstPollReceived = 1
			end

			local facing = GetPlayerFacing()
			local zone = GetZoneText("player")
			local subzone = GetSubZoneText("player")
			local speed = GetUnitSpeed("player")
			local movement = ""

			if speed == 7 then
				movement = "Normal running"
			elseif speed == 2.5 then
				movement = "Walking"
			elseif speed == 4.5 then
				movement = "Running backwards"
			elseif speed == 26.6 then
				movement = "Epic flying mount"
			elseif speed == 4.7222199440002 then
				movement = "Swimming"
			elseif speed == 0 then
				movement = "Still"
			else
				movement = "unknown"
			end

			local unitX, unitY = GetPlayerMapPosition("player")
			local output = "P#" .. msg .. "#" .. UnitName("Player") .. "#" .. subzone .. "#" ..tostring(unitX) .. "#" .. tostring(unitY) .. "#0.0#" .. facing .. "#" .. movement .. "\r"
			if (SCisRes == 1) then
				--to make sure the message is logged even if there's no party yet, since the polls are no longer delayed until "start" is sent
				sendWhisperToResearcherLogger(output)
			elseif (SCinitializedParticipant == 1) then
				sendToResearcherLogger(output);
			end
		end
	end
end)



local ChatListenFrame = CreateFrame("Frame");

ChatListenFrame:RegisterEvent("CHAT_MSG_PARTY");
ChatListenFrame:RegisterEvent("CHAT_MSG_PARTY_LEADER");
ChatListenFrame:RegisterEvent("CHAT_MSG_SAY");
ChatListenFrame:RegisterEvent("CHAT_MSG_YELL");
ChatListenFrame:RegisterEvent("CHAT_MSG_WHISPER");
ChatListenFrame:RegisterEvent("CHAT_MSG_WHISPER_INFORM");
ChatListenFrame:SetScript("OnEvent", function(event, ...)

	local eType = select(1, ...); -- eventType
	local msg = select(2, ...); -- message
	local sender = select(3, ...); -- sender
	local lang = select(4, ...); -- language
	local cS = select(5, ...); -- channelString
	local target = select(6, ...); -- target (not always used)
	local eleven = select(11, ...); -- sender? gets zero (documentation says this should be chat lineID)
	local lineID = select(12, ...); -- chat lineID (documentation says this shold be sender GUID)
	--trace("A chat was noticed: " .. eType .. ", " .. msg .. ", " .. sender .. ", " .. eleven .. ", " .. lineID);


	--get rid of upper-case characters for matching
	local str3tosearch = string.find(string.lower(msg), SCcode);

	if ((str3tosearch ~= nil) and (SCcheckpoint == 390) and ((GetSubZoneText() == "The Violet Citadel") or (GetSubZoneText() == "The Purple Parlor"))) then
		SendAddonMessage("SCv1", "SOLVED", "PARTY");
	end;

	if ((str3tosearch ~= nil) and (SCcheckpoint == 420) and (GetSubZoneText() == "Cantrips & Crows")) then
		SendAddonMessage("SCv1", "AZUKK", "PARTY");
	end;

	if (eType == "CHAT_MSG_SAY") then
		if sender == UnitName("Player") then
			local output = "C#" .. UnitName("Player") .. "#" .. msg .. "\r"
			if (sameFacMsg == 1) then
				SendAddonMessage("log", output, "WHISPER", nSed);
			else
				MsendToResearcherLogger(output, "chatAndEvents");
			end
		end

	elseif (eType == "CHAT_MSG_YELL") then
		--In 3.2.11, changed to only log if your toon did the yelling
		if (sender == UnitName("player")) then
			local output = "Y#" .. sender .. "#yelled " .. msg .. "\r"
			if (SClisteners == 1) then
				--sendToShortGuy(msg, "yell");
				SendAddonMessage("SCSHORTYELL", msg, "WHISPER", SCSourceBaddie);
			else
				MsendToResearcherLogger(output, "chatAndEvents");
				--trace("called MsendToResearcherLogger at Marauder:1563")
			end
		end

	--elseif (eType == "CHAT_MSG_WHISPER") then
		--31JAN2012 decided we don't need to log incoming whispers... only outgoing
		--incoming whispers from players (so the sender is listed first, as the whisper source)
		--local output = "W#" .. sender .. "#" .. msg .. "#" .. UnitName("Player") .. "\r"
		--this event only fires when the player receives a whisper, so no need to check whether target name matches
		--MsendToResearcherLogger(output, "chatAndEvents")
		--trace("called MsendToResearcherLogger at Marauder:1573")

	elseif (eType == "CHAT_MSG_WHISPER_INFORM") then
		--outgoing whispers to other players (so the player is listed first, as the whisper source)
		if target == nil then
			target = " "
		end
		--local numPartyMembers = GetNumPartyMembers()
		--local nonPartyMember = 1
		--for i = 1, numPartyMembers do
			--local participantName = GetUnitName("party" .. i)
			--if (target == participantName) then
				--nonPartyMember = 0
				--break
			--end
		--end

		--if nonPartyMember == 1 then
			local output = "W#" .. UnitName("Player") .. "#" .. msg .. "#" .. target .. "\r"
			MsendToResearcherLogger(output, "chatAndEvents")
			--trace("called MsendToResearcherLogger at Marauder:1594")
		--end

	elseif (eType == "CHAT_MSG_PARTY") then
		local output = "PC#" ..  UnitName("Player") .. "#" .. msg .. "\r"
		if sender == UnitName("Player") then
			MsendToResearcherLogger(output, "chatAndEvents")
		end
	elseif (eType == "CHAT_MSG_PARTY_LEADER") then
		local output = "PL#" ..  UnitName("Player") .. "#" .. msg .. "\r"
		if sender == UnitName("Player") then
			MsendToResearcherLogger(output, "chatAndEvents")
		end
	end
end);

local ZoneUpdateFrame = CreateFrame("Frame");
--to track location for zaps
ZoneUpdateFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
ZoneUpdateFrame:RegisterEvent("ZONE_CHANGED");
ZoneUpdateFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
ZoneUpdateFrame:SetScript("OnEvent", function(event, ...)
	if ((SCrune == 0) and (GetSubZoneText() == "Runeweaver Square")) then
		zapMe();
		SCrune = 1;
	elseif ((SCdal1 == 0) and (GetSubZoneText() == "Dalaran") and (SCcheckpoint == 305)) then
		rogueSoundLauncher(2);
		SCdal1 = 1;
	elseif ((SCviol == 0) and (GetSubZoneText() == "The Violet Citadel")) then
		zapMe();
		SCviol = 1;
	elseif ((SCund == 0) and (GetSubZoneText() == "The Underbelly")) then
		zapMe();
		SCund = 1;
	elseif ((SCring == 0) and (GetSubZoneText() == "Circle of Wills") and (SCcheckpoint == 490)) then
		rogueSoundLauncher(2);
		SCring = 1;
	elseif ((SCrpt3 == 0) and (GetSubZoneText() == "The Underbelly") and (SCcheckpoint == 790)) then
		rogueSoundLauncher(5);
		SCrpt3 = 1
	end
end)



local EmoteListenFrame = CreateFrame("Frame");
-- Will be used to monitor Chat for emotes (for Azukk)
--NOTE: this is only to listen for the first bad emote, to trigger the Zap cycle
EmoteListenFrame:RegisterEvent("CHAT_MSG_EMOTE");
EmoteListenFrame:RegisterEvent("CHAT_MSG_TEXT_EMOTE");
EmoteListenFrame:SetScript("OnEvent", function(event, ...)
	local eType = select(1, ...); -- eventType
	local msg = select(2, ...); -- message
	local sender = select(3, ...); -- sender
	local four = select(4, ...);
	local five = select(5, ...);
	local six = select(6, ...);
	local seven = select(7, ...);
	local eight = select(8, ...);
	local nine = select(9, ...);
	local ten = select(10, ...);
	local eleven = select(11, ...); -- sender? gets zero (documentation says this should be chat lineID)
	local lineID = select(12, ...); -- chat lineID? gets zero (documentation says this shold be sender GUID)
	--trace("An emote was noticed: eType=" .. eType .. ";msg=" .. msg .. ";sender=" .. sender .. "four=" .. four .. ";five=" .. five .. ";six=" .. six .. ";seven=" .. seven .. ";eight=" .. eight .. ";nine=" .. nine .. ";ten=" .. ten .. ";eleven=" .. eleven .. ", " .. lineID);
	str1tosearch = string.find(msg,"You flex");
	str2tosearch = string.find(msg,"flexes");
	strxtosearch = string.find(msg,"You ");
	strStosearch = string.find(msg,"roars with bestial vigor at you");
	if ((GetSubZoneText() == "Violet Stand") and (strStosearch ~= nil) and ((UnitName("Player") == "Sedrick") or (UnitName("Player") == "Seddrik") or (UnitName("Player") == "Padagenx"))) then
		--this should be Seddrik hearing the assassin at the beginning, triggering rogue sound and overhead text
		SendAddonMessage("SRv1", "ASSASSIN", "PARTY")
		--and for testing, do this locally too
		rogueSoundLauncher(0);
	elseif ((SCcheckpoint == 450) and (GetSubZoneText() == "Cantrips & Crows") and (closeEnough(0.02, 0.3760, 0.6040)) and (str1tosearch ~= nil) and (UnitInParty(sender))) then
		ChatWhisper("Azukk", "Aye, that flexin' honors m' beloved Rhudoh. Get all yer friends to do the same.");
		AddToOverheadQuick(ScreenTxt.line0108a);
		SendAddonMessage("SCv1", "EMOTED", "PARTY");
		local output = "FB#" .. UnitName("Player") .. "#" .. "performed the correct emote\r";
		MsendToResearcherLogger(output, "chatAndEvents"); -- send to researcher log as well
		SCcheckpoint = 460; -- so that, once a player does the right one and gets a whisper, they won't get the error message again
	elseif ((SCcheckpoint == 450) and (GetSubZoneText() == "Cantrips & Crows") and (closeEnough(0.02, 0.3760, 0.6040)) and (str2tosearch ~= nil) and (UnitInParty(sender))) then
		--do nothing if you hear someone else do the flex
	elseif ((SCcheckpoint == 450) and (GetSubZoneText() == "Cantrips & Crows") and (closeEnough(0.02, 0.3760, 0.6040)) and (UnitInParty(sender))) then
		--for each incorrect emote
		AddToOverheadQuick(ScreenTxt.line0108);
		local output = "FB#" .. UnitName("Player") .. "#" .. "performed the wrong emote\r";
		MsendToResearcherLogger(output, "chatAndEvents"); -- send to researcher log as well
	end;

	--every time the local character performs an emote
	if (sender == UnitName("Player")) then

		if (eType == "CHAT_MSG_TEXT_EMOTE") then
			--print("should send log about E#")
			local output = "E#" .. UnitName("Player") .. "#" .. msg .. "\r";
			if (SCinitializedParticipant == 1) then
				MsendToResearcherLogger(output, "chatAndEvents");
			elseif (SClisteners == 1) then
				--sendToShortGuy(msg, "emo") -- going to GUILD via SendAddonMessage
				SendAddonMessage("SCSHORTEMO", output, "WHISPER", SCSourceBaddie)
			elseif (sameFacMsg == 1) then
				SendAddonMessage("log", output, "WHISPER", nSed);
			end

		elseif (eType == "CHAT_MSG_EMOTE") then
			--print("should send log about CE#")
			local output = "CE#" .. UnitName("Player") .. "#" .. msg .. "\r";
			if (SCinitializedParticipant == 1) then
				MsendToResearcherLogger(output, "chatAndEvents");
			elseif (SClisteners == 1) then
				--sendToShortGuy(msg, "custemo") -- going to GUILD via SendAddonMessage
				SendAddonMessage("SCSHORTCUSTEMO", output, "WHISPER", SCSourceBaddie)
			elseif (sameFacMsg == 1) then
				SendAddonMessage("log", output, "WHISPER", nSed);
			end
		end

	end;

end);

--==========================================
--Combat Log parser function
--==========================================

local CombatListenFrame = CreateFrame("Frame");
--trace("created frame");
--CombatFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEvent");
CombatListenFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
--trace("registered");
--CombatFrame:SetScript("OnEvent", function(timestamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, destinationGUID, destinationName, destinationFlags, ...)
CombatListenFrame:SetScript("OnEvent", function(event, ...)
	local output = ""
	local i = 0
	local j = 0
	--trace("A CombatLogEvent occurred: " .. timestamp .. ", " .. eventType .. ", " .. tostring(hideCaster) .. ", " .. tostring(sourceGUID) .. ", " .. sourceFlags .. ", " .. destinationFlags .. ", " .. tostring(destinationGUID) .. ", " .. destinationName);
	local ev = select(1, ...); -- (event) [parameter 0]
	local ts = select(2, ...); -- timestamp [parameter 1]
	local eT = select(3, ...); -- eventType [parameter 2]
	local hC = select(4, ...); -- hideCaster [parameter 3]
	local sG = select(5, ...); -- sourceGUID [parameter 4]
	local sN = select(6, ...); -- sourceName [parameter 5]
	local sF = select(7, ...); -- sourceFlags [parameter 6]
	local sF2 = select(8, ...); -- sourceFlags2 [parameter 7, added in 4.2]
	local dG = select(9, ...); -- destGUID [parameter 8, shifted as of 4.2]
	local dN = select(10, ...); -- destName [parameter 9, shifted as of 4.2]
	local dF = select(11, ...); -- destFlags [parameter 10, shifted as of 4.2]
	local dF2 = select(12, ...); --destFlags2 [parameter 11, added in 4.2]
	local param12 = select(13, ...); -- parameter 12
	local param13 = select(14, ...); -- parameter 13
	local param14 = select(15, ...); -- parameter 14
	local param15 = select(16, ...); -- parameter 15
	local param16 = select(17, ...); -- parameter 16
	--trace("A CombatLogEvent occurred: " .. ts .. ", " .. eT .. ", " .. tostring(hC) .. ", " .. tostring(sG) .. ", " .. sF .. ", " .. dF .. ", " .. tostring(dG) .. ", " .. dN);

	--Seddrick's death at the beginning
	--Now (3.1.9) use this as a trigger rather than the old KILL button
	-- Only trigger with the first hit
	--As of 3.2.5, remove the variable update and Overhead screen text from automatic triggering in combat
	--   Will be tied to a macro that plays the stealth sound and then displays the overhead
	--if (((eT == "SWING_DAMAGE") or (eT == "SPELL_DAMAGE")) and (SCcheckpoint == 70) and ((dN == "Seddrik") or (dN == "Sedrick"))) then
		--trace(eT .. ": " .. sN .. " damaged " .. dN)
	--end

	--trace("A combat log event occurred: source GUID " .. sG);
	--record the last damage-dealer, to determine whether a kill was done by a player or a pet
	if (((eT == "SWING_DAMAGE") or (eT == "SPELL_DAMAGE")) and ((dN == "Rabbit") or (dN == "Squirrel") or (dN == "Underbelly Rat") or (dN == "Sewer Frog"))) then
		--trace(eT .. ": " .. sN .. " damaged " .. dN)
		SCLastDamager = sG
	end

	--squirrel kill by player
	if ((eT == "PARTY_KILL") and (dN == "Squirrel") and (sG == UnitGUID("player")) and (SCcheckpoint >= 140)) then
		--trace("I killed a squirrel");
		SendAddonMessage("SCv1", "SQUIRRELKILL", "PARTY");
		local output = "FB#" .. UnitName("Player") .. "#" .. "killed a squirrel\r";
		sendToResearcherLogger(output);

	elseif ((eT == "UNIT_DIED") and (dN == "Squirrel") and (SCLastDamager == UnitGUID("pet")) and (SCcheckpoint >= 140)) then
		--trace("My pet killed a squirrel");
		SendAddonMessage("SCv1", "SQUIRRELKILLPET", "PARTY");
		local output = "FB#" .. UnitName("Player") .. "#" .. "pet killed a squirrel\r";
		sendToResearcherLogger(output);

	--bunny kill
	elseif ((eT == "PARTY_KILL") and (dN == "Rabbit") and (sG == UnitGUID("player")) and (SCcheckpoint >= 140)) then
		--trace("I killed a bunny");
		SendAddonMessage("SCv1", "BUNNYKILL", "PARTY");
		local output = "FB#" .. UnitName("Player") .. "#" .. "killed a rabbit\r";
		sendToResearcherLogger(output);

	elseif ((eT == "UNIT_DIED") and (dN == "Rabbit") and (SCLastDamager == UnitGUID("pet")) and (SCcheckpoint >= 140)) then
		--trace("My pet killed a bunny");
		SendAddonMessage("SCv1", "BUNNYKILLPET", "PARTY");
		local output = "FB#" .. UnitName("Player") .. "#" .. "pet killed a rabbit\r";
		sendToResearcherLogger(output);

	--rat kill
	elseif ((eT == "PARTY_KILL") and (dN == "Underbelly Rat") and (sG == UnitGUID("player")) and (SCcheckpoint == 530)) then
		--trace("I killed a rat");
		SendAddonMessage("SCv1", "RATKILL", "PARTY");
		local output = "FB#" .. UnitName("Player") .. "#" .. "killed a rat\r";
		sendToResearcherLogger(output);

	elseif ((eT == "UNIT_DIED") and (dN == "Underbelly Rat") and (SCLastDamager == UnitGUID("pet")) and (SCcheckpoint == 530)) then
		--trace("My pet killed a rat");
		SendAddonMessage("SCv1", "RATKILLPET", "PARTY");
		local output = "FB#" .. UnitName("Player") .. "#" .. "pet killed a rat\r";
		sendToResearcherLogger(output);

	--frog kill
	elseif ((eT == "PARTY_KILL") and (dN == "Sewer Frog") and (sG == UnitGUID("player")) and (SCcheckpoint == 530)) then
		--trace("I killed a frog");
		SendAddonMessage("SCv1", "FROGKILL", "PARTY");
		local output = "FB#" .. UnitName("Player") .. "#" .. "killed a frog\r";
		sendToResearcherLogger(output);

	elseif ((eT == "UNIT_DIED") and (dN == "Sewer Frog") and (SCLastDamager == UnitGUID("pet")) and (SCcheckpoint == 530)) then
		--trace("My pet killed a frog");
		SendAddonMessage("SCv1", "FROGKILLPET", "PARTY");
		local output = "FB#" .. UnitName("Player") .. "#" .. "pet killed a frog\r";
		sendToResearcherLogger(output);

	elseif ((eT == "UNIT_DIED") and ((dN == "Rabbit") or (dN == "Squirrel") or (dN == "Underbelly Rat") or (dN == "Sewer Frog")) and (SCcheckpoint >= 530)) then
		--trace(dN .. " died, but didn't hit on my conditions: source GUID " .. sG)

	--shark kill (doesn't ID shark, but it's a sanctuary an no aggro NPCs.. so unlikely to die there any other way)
	elseif ((eT == "UNIT_DIED") and (dN == GetUnitName("player")) and (SCcheckpoint == 660)) then
		--trace("got killed");
		SendAddonMessage("SCv1", "SHARK", "PARTY");
		local output = "D#" .. GetUnitName("player") .. "\r";
		MsendToResearcherLogger(output, "chatAndEvents")

	elseif ((eT == "UNIT_DIED") and ((dN == "Izuna") or (dN == "Izunai"))) then
		--log Izu's death for coordinating party and off-faction log timestamps (Izu logs the PLAYER_DIED event)
		local output = "D#" .. dN .. "\r";
		if (SCinitializedParticipant == 1) then
			MsendToResearcherLogger(output, "chatAndEvents")
		elseif
			(SClisteners == 1) then
			sendToOffFacResearcherLogger(output, "chatAndEvents", SCSourceBaddie)
		end
	end

	---Take subevent and strip prefix---
	---If prefix contains range, spell, spell_periodic, spell_building, then get 13th parameter
	i, j = string.find(eT, "RANGE")
	if (i ~= nil) then
		SCdetail1 = param13
		SCdetail1set = 1
		--print("detail1_RANGE: " .. "X" .. detail1 .. "X")
	end

	i, j = string.find(eT, "SPELL")
	if (i ~= nil) then
		SCdetail1 = param13
		SCdetail1set = 1
		--print("detail1_SPELL: " .. "X" .. detail1 .. "X")
	end

	---If prefix contains environmental get 12th parameter
	i, j = string.find(eT, "ENVIRONMENTAL")
	if (i ~= nil) then
		SCdetail1 = param12
		SCdetail1set = 1
		--print("detail1_ENVIRONMENTAL: " .. "X" .. detail1 .. "X")
	end

	---If suffix contains "AURA" but not "AURA_BROKEN_SPELL" then get 15th parameter
	i, j = string.find(eT, "AURA")
	if ((i ~= nil) and (j == 4)) then
		SCdetail2 = param15
		SCdetail2set = 1
		--print("detail2_AURA: " .. "X" .. detail2 .. "X")
	end

	---If suffix contains "AURA_BROKEN_SPELL" then get 16th parameter
	i, j = string.find(eT, "AURA_BROKEN_SPELL")
	if (i ~= nil) then
		SCdetail2 = param16
		SCdetail2set = 1
		--print("detail2_AURA_BROKEN_SPELL: " .. "X" .. detail2 .. "X")
	end

	---If suffix contains "INTERRUPT", "DISPEL", "DISPEL_FAILED", "STOLEN" then get 16th parameter
	i, j = string.find(eT, "INTERRUPT")
	if (i ~= nil) then
		SCdetail2 = param16
		SCdetail2set = 1
		--print("detail2_INTERRUPT: " .. "X" .. detail2 .. "X")
	end

	i, j = string.find(eT, "DISPEL")
	if (i ~= nil) then
		SCdetail2 = param16
		SCdetail2set = 1
		--print("detail2_DISPEL: " .. "X" .. detail2 .. "X")
	end

	i, j = string.find(eT, "DISPEL_FAILED")
	if (i ~= nil) then
		SCdetail2 = param16
		SCdetail2set = 1
		--print("detail2_DISPEL_FAILED: " .. "X" .. detail2 .. "X")
	end

	i, j = string.find(eT, "STOLEN")
	if (i ~= nil) then
		SCdetail2 = param16
		SCdetail2set = 1
		--print("detail2_STOLEN: " .. "X" .. detail2 .. "X")
	end

	if (SCdetail1set == 0) then
		detail1 = nil
	end

	if (SCdetail2set == 0) then
		detail2 = nil
	end

	--#######Getting when player is  attacking######################
	if (sN == UnitName("Player")) then

		if (dN == nil) then
			dN = "unknown"
		end

		if ((detail1 ~= nil) and (detail2 ~= nil)) then
			output = "CB#" .. sN .. "#" .. eT .. "#" .. detail1 .. "#" .. detail2 .. "#" ..  dN ..  "\r"
		elseif (detail1 ~= nil)  then
			output = "CB#" .. sN .. "#" .. eT .. "#" .. detail1 .. "#" .. dN .. "\r"
		elseif (detail2 ~= nil) then
			output = "CB#" .. sN .. "#" .. eT .. "#" ..  detail2 .. "#"  .. dN .. "\r"
		end

		--print("Player is attacking, should be sending using MsendToResearcherLogger with output=" .. output)
		if (SCinitializedParticipant == 1) then
			MsendToResearcherLogger(output, "chatAndEvents")
		elseif (sameFacMsg == 1) then
			SendAddonMessage("log", output, "WHISPER", nSed);
		--elseif (SClisteners == 1) then
			--sendToOffFacResearcherLogger(output, "chatAndEvents", SCSourceBaddie)
		else
			--print("didn't find anyone to send log message to, Marauder.lua line 1930");
		end
	end


	--#####Getting when the player is attacked##########################
	if (dN ~= nil) then
		if dN == UnitName("Player") then
			--adding to get around "attempt to concatenate local 'sourceName' (a nil value) error gotten
			--sometimes when toon dies
			if (sN == nil) then
				sN =  "unknown"
			end

			if ((detail1 ~= nil) and (detail2 ~= nil)) then
				output = "CB#" .. sN .. "#" .. eT .. "#" .. detail1 .. "#" .. detail2 .. "#" ..  dN ..  "\r"
			elseif (detail1 ~= nil)  then
				output = "CB#" .. sN .. "#" .. eT .. "#" .. detail1 .. "#" .. dN .. "\r"
			elseif (detail2 ~= nil) then
				output = "CB#" .. sN .. "#" .. eT .. "#" ..  detail2 .. "#"  .. dN .. "\r"
			end
			--SendAddonMessage("log", output, "PARTY")

			--print("Player being attacked, should be sending using MsendToResearcherLogger with output=" .. output)
			if (SCinitializedParticipant == 1) then
				MsendToResearcherLogger(output, "chatAndEvents")
			elseif (sameFacMsg == 1) then
				SendAddonMessage("log", output, "WHISPER", nSed);
			--elseif (SClisteners == 1) then
				--sendToOffFacResearcherLogger(output, "chatAndEvents", SCSourceBaddie)
			else
				--print("didn't find anyone to send log message to, Marauder.lua line 1961");
			end
		end
	end

end); --of the CombatFrame script


local SystemMsgFrame = CreateFrame("Frame");
--for Duels and Trading notices
SystemMsgFrame:RegisterEvent("CHAT_MSG_SYSTEM");
SystemMsgFrame:SetScript("OnEvent", function(event, ...)

	local msg = select(2, ...);

	--if (string.find(msg, "You have requested to trade with") ~= nil) then
		--local array msgArray = {strsplit(" ", msg)}
		--local avatarNameLength = strlen(msgArray[#msgArray])
		--local output = "TRDReq#" ..  UnitName("Player") .. "#requested trade with " .. strsub(msgArray[#msgArray], 1, avatarNameLength - 1) .. "\r"
		--MsendToResearcherLogger(output, "chatAndEvents")
	--elseif (string.find(msg, "has requested to trade with you") ~= nil) then
		--local array msgArray = {strsplit(" ", msg)}
		--local output = "TRDReq#" .. msgArray[1] .. " requested trade with " .. UnitName("Player");
		--MsendToResearcherLogger(output, "chatAndEvents")
	if (string.find(msg, "has defeated")) then
		local winner = string.gsub(msg, "(.*) has defeated (.*) in a duel", "%1", 1);
		local loser = string.gsub(msg, "(.*) has defeated (.*) in a duel", "%2", 1);
		--print(winner .. " has defeeted " .. loser .. " in a duelicious duel");
		if ((winner == UnitName("player")) and (SCDuelWon == 0) and (SCcheckpoint == 600)) then
			--trace("sent DUEL message");
			SendAddonMessage("SCv1", "DUEL", "PARTY");
			local output = "FB#" .. UnitName("Player") .. "#" .. "beat" .. loser .. " in a duel\r";
			sendToResearcherLogger(output);
			SCDuelWon = 1; -- the winning player sets this variable locally
		end;
	end;
end); --of the SystemMsgFrame script


-- #######################################################
-- OnLoad function
-- #######################################################
function handleOnLoad(self)
	trace("");
	trace("|cffff8000Marauder|r: Marauder loaded");
	trace(" ");
	-- Setup events
	self:RegisterEvent('VARIABLES_LOADED');
	self:RegisterEvent("MERCHANT_SHOW");
	self:RegisterEvent("MERCHANT_CLOSED");
	self:RegisterEvent("MERCHANT_UPDATE");
	self:RegisterEvent("ITEM_PUSH");
	self:RegisterEvent("CHAT_MSG_LOOT");
	self:RegisterEvent("CHAT_MSG_TRADESKILLS");
	self:RegisterEvent("TRADE_SHOW");
	self:RegisterEvent("PLAYER_MONEY");
	self:RegisterEvent("PLAYER_DEAD");
	self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
	self:RegisterEvent("UNIT_TARGET");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_LOGOUT");
	self:RegisterEvent("BAG_UPDATE");

end
-- #######################################################

-- #######################################################
-- Event handlers
-- #######################################################
function handleOnEvent(self, event, ...)
	--trace("Marauder: handleOnEvent event = " .. event);

	if ((event == "MERCHANT_UPDATE") and (SCinitializedParticipant == 1)) then
		--self:Print(event)
		merchantUpdate = 1
	end

	if ((event == "ITEM_PUSH") and (SCinitializedParticipant == 1)) then
		itemPush=1
		--self:Print(event)
	end

	if ((event == "CHAT_MSG_LOOT") and (SCinitializedParticipant == 1)) then
		local msg = select(1, ...)
		--print("CHAT_MSG_LOOT fired: " .. msg);
		--self:Print(event)
		local array msgArray = {strsplit("[", msg)}
		local cleanedLootArray = {strsplit("]", msgArray[2])}
		--if playerMoney and itemPush fire before this then there was a purchase
		if (playerMoney == 1 and itemPush == 1 and merchantUpdate == 1) then
			playerMoney = 0
			itemPush = 0
			merchantUpdate = 0
			local output = "PR#" ..  UnitName("Player") .. "#" .. cleanedLootArray[1] .. "\r"
			MsendToResearcherLogger(output, "chatAndEvents")
			--self:Print(output)
		end
	end

	if ((event == "CHAT_MSG_TRADESKILLS") and (SCcheckpoint == 285)) then
		local msg = select(1, ...);
		--print("CHAT_MSG_TRADESKILLS fired: " .. msg);
		local crafted = string.match(msg, "You create (Copper Bar)");
		if (crafted ~= nil) then
			--trace("congrats on the " .. crafted .."!");
			SendAddonMessage("SCv1", "COPPER", "PARTY");
		end
	end

	if ((event == "TRADE_SHOW") and (SCinitializedParticipant == 1)) then
		local thatguy, thang = UnitName("NPC")
		local output = "TRDReq#" .. GetUnitName("player") .. "#" .. thatguy .. "\r"
		MsendToResearcherLogger(output, "chatAndEvents");
	end

	if ((event == "PLAYER_MONEY") and (SCinitializedParticipant == 1)) then
		playerMoney=1
		local origMoney = money
		money = GetMoney()
		diffMoney = money - origMoney
		if (diffMoney ~= 0) then
			output = "BU#" .. UnitName("Player") .. "#copper#" .. diffMoney .. "\r"
		end
		MsendToResearcherLogger(output, "chatAndEvents")
		--self:Print(output)
	end

	--if (event == "PLAYER_DEAD") then
		--local output = "D#" .. UnitName("Player") .. "\r"
		--if (SCinitializedParticipant == 1) then
			--MsendToResearcherLogger(output, "chatAndEvents")
		--elseif
			--(SClisteners == 1) then
			--sendToOffFacResearcherLogger(output, "chatAndEvents", SCSourceBaddie)
		--end
	--end

	if ((event == "PLAYER_EQUIPMENT_CHANGED") and (SCinitializedParticipant == 1)) then
		local slot = select(1, ...)
		local hasItem = select(2, ...)

		--hasItem would be 1 if putting on item
		if hasItem == 1 then

			local equippedItemId = equippedItems[slot + 1]
			if (equippedItemId > 0) then
				local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(equippedItemId)
				local output = "UE#" .. UnitName("Player") .. "#" .. name .. "\r"
				--SendAddonMessage("log", output, "PARTY")
				MsendToResearcherLogger(output, "chatAndEvents")
				--self:Print(output)
			end

			--update equippedItems table
			local id = GetInventoryItemID("Player", slot)
			--table.insert(equippedItems, slot + 1, id)
			equippedItems[slot+1] = id
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(id)
			local output = "EQ#" .. UnitName("Player") .. "#" .. name .. "\r"
			--SendAddonMessage("log", output, "PARTY")
			MsendToResearcherLogger(output, "chatAndEvents")
			--self:Print(output)
		else
			local id = equippedItems[slot + 1]
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(id)
			local output = "UE#" .. UnitName("Player") .. "#"  .. name .. "\r"
			equippedItems[slot + 1]=0
			--SendAddonMessage("log", output, "PARTY")
			MsendToResearcherLogger(output, "chatAndEvents")
			--self:Print(output)
		end
	end

	if ((event == "UNIT_TARGET") and (SCinitializedParticipant == 1)) then
		local unitID = select(1, ...)
		local name = UnitName("target")
		--adding to get around "attempt to concatenate local 'name' (a nil value) error gotten
		--sometimes when using UnitName("mouseover") to get name of NPC
		if (name ~= nil) then
			if (UnitName(unitID) == UnitName("Player")) then
				local output = "TGT#" .. UnitName(unitID) .. "#" .. name .. "\r"
				MsendToResearcherLogger(output, "chatAndEvents")
			end
		end
	end

	if ((event == "PLAYER_REGEN_ENABLED") and (SCinitializedParticipant == 1)) then
		--SRL changed tag name from RegenON to OutComb for easier analysis = out of combat
		local output = "OutComb#" .. UnitName("Player") .. "\r"
		MsendToResearcherLogger(output, "chatAndEvents")
	end

	if ((event == "PLAYER_REGEN_DISABLED") and (SCinitializedParticipant == 1)) then
		--SRL changed tag name from RegenOFF to InComb for easier analysis = in combat
		local output = "InComb#" .. UnitName("Player") .. "\r"
		MsendToResearcherLogger(output, "chatAndEvents")
	end

	if ((event == "PLAYER_LOGOUT") and (SCinitializedParticipant == 1)) then
		--self:Print(event)
		local output = "L#" .. UnitName("Player") .. "\r"
		MsendToResearcherLogger(output, "chatAndEvents")
	end

	if (event == 'VARIABLES_LOADED') then
		--setupInterfaceMenu();
		setupSlashCommands();
		setupGuildVariables();
		--iniStates();
	end

	--=====================================
	-- BAG Update
	--=====================================

	if ((event == "BAG_UPDATE") and (SCinitializedParticipant == 1)) then
		--self:Print(event .. " " .. bagID)
		count = count + 1
		local output= ""
		-------------------Create bag status #2--------------------------
		--create array used to store items from all bags, need item and #

		-- determining number of bags the player has
		local numBags = 0
		for i = 0, NUM_BAG_SLOTS do
			local name = GetBagName(i)
			if name ~= nil then
				numBags = numBags + 1
			end
		end

		MtableDelete(bagItemsAfter)
		--for each bag, get number of slots, go through each slot and save off itemId and number to bagItemsBefore{}
		for bag = 0, numBags-1 do
			local numSlots = GetContainerNumSlots(bag)

			--filling idTable with unique id values from slots in bags
			for slot = 1, numSlots do

				local id = GetContainerItemID(bag, slot)
				if id ~= nil then
					local itemCount = GetItemCount(id)
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(id)
					--self:Print(bag .. ", " .. slot .. ", " .. id .. ", " .. name .. ", " .. itemCount)
					bagItemsAfter[id]=itemCount
				end
			end
		end

		--count the number of items in bagItemsAfter
		local bagItemsAfterItemsNo = 0
		for k,v in pairs(bagItemsAfter) do
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
			bagItemsAfterItemsNo = bagItemsAfterItemsNo + 1
		end

		--count the number of items in bagItemsBefore
		local bagItemsBeforeItemsNo = 0
		for k,v in pairs (bagItemsBefore) do
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
			bagItemsBeforeItemsNo = bagItemsBeforeItemsNo + 1
		end


		--self:Print("count " .. count .. "bagB4#: " .. bagItemsBeforeItemsNo .. " " .. "bagAfter#: " .. bagItemsAfterItemsNo)
		--self:Print("----------------------------------------------------")
		-----------------------------------------------------------------


		--iterate over bagItemsAfter and compare itemCount between both bags
		if (bagItemsAfterItemsNo == bagItemsBeforeItemsNo) then
			--self:Print("in here")
			for k,v in pairs(bagItemsAfter) do
				--12/20 had to add the bagItemsBefore[k] clause in case the number of items in each bag is the same but items were switched so that
				--the new item did not exist in the old bag
				if (bagItemsBefore[k] == nil) then
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					--because bag_update fires twice need to set bagItemsBefore to value in bagItemsAfter
					--bagItemsBefore[k] = v
					output = "BU#" .. UnitName("Player") .. "#" .. name .. "#" .. v .. "\r"
					MsendToResearcherLogger(output, "chatAndEvents")
					--self:Print("items equal: " .. output)
				elseif (v ~= bagItemsBefore[k]) then
					local diff = v - bagItemsBefore[k]
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					--because bag_update fires twice need to set bagItemsBefore to value in bagItemsAfter
					output = "BU#" .. UnitName("Player") .. "#" .. name .. "#" .. diff .. "\r"
					--self:Print("items equal: " .. output)
					MsendToResearcherLogger(output, "chatAndEvents")
				end
			end
			--12/20 Added whole clause below realizing that there might be a swap where an item from bagItemsBefore is replaced (haven't come across an instance of)
			for k,v in pairs(bagItemsBefore) do
				--12/20 had to add the bagItemsAfter[k] clause in case the number of items in each bag is the same but items were switched so that
				--the new item did not exist in the old bag
				if (bagItemsAfter[k] == nil) then
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					--because bag_update fires twice need to set bagItemsBefore to value in bagItemsAfter
					--bagItemsAfter[k] = v
					output = "BU#" .. UnitName("Player") .. "#" .. name .. "#-" .. v .. "\r"
					MsendToResearcherLogger(output, "chatAndEvents")
				--self:Print("items equal: " .. output)
				end
			end
		--if bagb4 < bagAfter then added an item, what is that item
		elseif (bagItemsBeforeItemsNo < bagItemsAfterItemsNo) then
			for k,v in pairs(bagItemsAfter) do
				if (bagItemsBefore[k] == nil) then
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					--because bag_update fires twice need to set bagItemsBefore to value in bagItemsAfter
					--bagItemsBefore[k] = v
					output = "BU#" .. UnitName("Player") .. "#" .. name .. "#" .. v .. "\r"
					--self:Print("bAfter > bb4: " .. output)
					MsendToResearcherLogger(output, "chatAndEvents")
				end
			end
		--if bagb4 > bagAfter then deleted an item entirely, what is that item
		elseif (bagItemsBeforeItemsNo > bagItemsAfterItemsNo) then

			for k,v in pairs(bagItemsBefore) do
				if (bagItemsAfter[k] == nil) then
					local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(k)
					--because bag_update fires twice need to set bagItemsBefore to value in bagItemsAfter
					--bagItemsBefore[k] = nil
					output = "BU#" .. UnitName("Player") .. "#" .. name .. "#" .. "-" .. v .. "\r"
					--self:Print("bAfter < bb4: " .. output)
					MsendToResearcherLogger(output, "chatAndEvents")
				end
			end
		end

		MtableDelete(bagItemsBefore)
		bagItemsBefore = MtableCopy(bagItemsAfter)

	end
end
-- #######################################################

--create a custom function to do/insert something when the secure function is run
function SClogjumps()
	if (SCinitializedParticipant == 1) then
		--trace("logged a jump or other upward motion event, including flying or swimming up");
		local output = "JMP#" .. UnitName("Player") .. "#" .. "jumped\r";
		sendToResearcherLogger(output);
	end
end

--include this code in the root of Marauder
hooksecurefunc("JumpOrAscendStart", SClogjumps)

